//Modify date: 2008/01/10
//Purpose : Change the BCR module in "single read" or "multiple read"mode
//Method:
//    (1) BCRCom.BCR_UPDATE_SETTING(ref uint ResultOut) 
//    Configure BCR Service and BCR Module by setting 
//          (1.1)"BCRCom.dwMask_Status" to be
//                  MASK_READ_MODE= 0x0010
//          (1.2)"BCRCom.dwReadMode" to be
//                  BCRSTATUS_RD_MODE_SINGLE = 1
//                  BCRSTATUS_RD_MODE_MULTIPLE = 2
//          (1.3)ResultOut is return value.    
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BCRServiceCOMLib;
namespace ChangeReadMode
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        uint MASK_READ_MODE = 0x0010;
        uint BCRSTATUS_RD_MODE_MULTIPLE = 2;
        uint BCRSTATUS_RD_MODE_SINGLE = 1;
        uint Result = 0;
        uint BCR_SUCCESS = 1;
        BCRServiceCOMLib.BCRClass BCRCom = new BCRServiceCOMLib.BCRClass();
        private void button1_Click(object sender, EventArgs e)
        {           
            BCRCom.dwMask_Status = MASK_READ_MODE;
            BCRCom.dwReadMode = BCRSTATUS_RD_MODE_SINGLE;
            BCRCom.BCR_UPDATE_SETTING(ref Result);
            if (Result == BCR_SUCCESS)
            {
                button1.Enabled = false;
                button3.Enabled = true;
                MessageBox.Show("Change Single Mode Success!");
            }
            else
            {
                MessageBox.Show("Change Single Mode fail!");
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            BCRCom.dwMask_Status = MASK_READ_MODE;
            BCRCom.dwReadMode = BCRSTATUS_RD_MODE_MULTIPLE;
            BCRCom.BCR_UPDATE_SETTING(ref Result);
            if (Result == BCR_SUCCESS)
            {
                button1.Enabled = true;
                button3.Enabled = false;
                MessageBox.Show("Change Multiple Mode Success!");
            }
            else
            {
                MessageBox.Show("Change Multiple Mode fail!");
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            if (BCRCom.dwReadMode == BCRSTATUS_RD_MODE_SINGLE)
            {
                button1.Enabled = false;
                button3.Enabled = true;
            }
            if( BCRCom.dwReadMode == BCRSTATUS_RD_MODE_MULTIPLE)
            {
                button1.Enabled = true;
                button3.Enabled = false;
            }

        }
    }
}