//Modify date: 2008/01/10
//Purpose : Enable or Disable Keyboard Hook when use BCR module 
//Method:
//    (1) BCRCom.BCR_UPDATE_SETTING(ref uint ResultOut) 
//          Configure BCR Service and BCR Module by setting 
//          (1.1)"BCRCom.dwMask_Status" to be
//                  MASK_KEYHOOK_EMABLE= 0x0080
//          (1.2)"BCRCom.dwKeyboardHook" to be
//                  BCRSTATUS_HOOK_OFF = 1
//                  BCRSTATUS_HOOK_ON   = 2
//          (1.3)ResultOut is return value.    
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BCRServiceCOMLib;

namespace Enable_DisableKeyboardHook
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        uint MASK_KEYHOOK_EMABLE = 0x0080;
        uint BCRSTATUS_HOOK_ON = 2;
        uint Result = 0;        
        uint BCRSTATUS_HOOK_OFF = 1;
        uint BCR_SUCCESS = 1;
        BCRServiceCOMLib.BCRClass BCRCom = new BCRServiceCOMLib.BCRClass();
        private void button1_Click(object sender, EventArgs e)
        {                       
            BCRCom.dwMask_Status = MASK_KEYHOOK_EMABLE;
            BCRCom.dwKeyboardHook = BCRSTATUS_HOOK_ON;
            BCRCom.BCR_UPDATE_SETTING(ref Result);
            if (Result == BCR_SUCCESS)
            {
                button1.Enabled = false;
                button2.Enabled = true;
                MessageBox.Show("Enable Keyboard Hook Success!");
            }
            else
            {
                MessageBox.Show("Enable Keyboard Hook fail");
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {                       
            BCRCom.dwMask_Status = MASK_KEYHOOK_EMABLE;
            BCRCom.dwKeyboardHook = BCRSTATUS_HOOK_OFF;
            BCRCom.BCR_UPDATE_SETTING(ref Result);
            if (Result == BCR_SUCCESS)
            {
                button1.Enabled = true;
                button2.Enabled = false;
                MessageBox.Show("Disable Keyboard Hook Success!");
            }
            else
            {
                MessageBox.Show("Disable Keyboard Hook fail");
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            if (BCRCom.dwKeyboardHook == BCRSTATUS_HOOK_ON)
            {
                button1.Enabled = false;
                button2.Enabled = true;
            }
            if(BCRCom.dwKeyboardHook == BCRSTATUS_HOOK_OFF)
            {
                button1.Enabled = true;
                button2.Enabled = false;
            }
        }
    }
}