//Modify date: 2008/01/10
//Purpose : Read com port data
//Method:
//          About keyboard hook:
//          (1)Call BCRCom.BCR_UPDATE_SETTING(ref Result) by setting
//          (1.1) Set "BCRCom.dwMask_Status" as 
//                   MASK_KEYHOOK_EMABLE = 0x0080
//          (1.2) Set "BCRCom.dwKeyboardHook" as
//                   BCRSTATUS_HOOK_ON = 2 for enable hook
//                   BCRSTATUS_HOOK_OFF = 1 for disable hook     
//          return error code "Result"
//
//          About module:
//          (2)Call BCRCom.BCR_UPDATE_SETTING(ref Result) by setting
//          (2.1) Set "BCRCom.dwMask_Status" as  
//                   MASK_MODULE_ENABLE = 0x0020    
//          (2.2) Set "BCRCom.dwModuleEnable" as
//                   BCRSTATUS_MOD_DISABLE = 1 for disable module     
//                   BCRSTATUS_MOD_ENABLE = 2 for enable module
//          return error code "Result"
//         
//          Get event name:
//          (3)BCRCom.BCR_GET_EVENTNAME(out EventName)
//          
//          Read Com port data:  
//          (4)BCRCom.BCR_READ_COMPORT_DATA()
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BCRServiceCOMLib;
using System.Threading;
using System.Runtime.InteropServices;

namespace ReadComPortData
{
    public partial class Form1 : Form
    {
        BCRServiceCOMLib.BCRClass BCRCom = new BCRServiceCOMLib.BCRClass();        
        uint BCR_TRIG_PRESS = 2;
        uint BCR_TRIG_RELEASE = 1;
        uint BCRSTATUS_HOOK_ON = 2;
        uint BCRSTATUS_HOOK_OFF = 1;
        uint BCRSTATUS_MOD_ENABLE = 2;
        uint BCRSTATUS_MOD_DISABLE = 1;
        uint BCR_SUCCESS = 1;
        uint MASK_KEYHOOK_EMABLE = 0x0080;
        uint MASK_MODULE_ENABLE = 0x0020;        
        uint Result = 0;
        uint BCRSTATUS_TK_DEFAULT = 1;
        uint BCRSTATUS_TK_START = 5;
        uint BCRSTATUS_TK_OK = 6;
        bool KeyHook = true;     
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {           
            BCRCom.dwMask_Status = MASK_KEYHOOK_EMABLE;
            BCRCom.dwKeyboardHook = BCRSTATUS_HOOK_ON;
            BCRCom.BCR_UPDATE_SETTING(ref Result);
            if (Result != BCR_SUCCESS)
            {
                MessageBox.Show("Enable Keyboard Hook fail");
            }           
            button2.Enabled = true;
            button1.Enabled = false;            
            KeyHook = true;
            textBox1.Focus();
        }

        private void button2_Click(object sender, EventArgs e)
        {                                 
            BCRCom.dwMask_Status = MASK_KEYHOOK_EMABLE;
            BCRCom.dwKeyboardHook = BCRSTATUS_HOOK_OFF;
            BCRCom.BCR_UPDATE_SETTING(ref Result);
            if (Result != 1)
            {
                MessageBox.Show("Disable Keyboard Hook fail");
            }            
            button1.Enabled = true;
            button2.Enabled = false;
            BCRCom.BCR_READ_COMPORT_DATA();
            textBox1.Focus();
            KeyHook = false;
            Thread newThread = new Thread(new ThreadStart(this.ThreadFunc));
            newThread.IsBackground = true;
            newThread.Start();           
            
        }

        private void button3_Click(object sender, EventArgs e)
        {         
            BCRCom.dwMask_Status = MASK_MODULE_ENABLE;
            BCRCom.dwModuleEnable = BCRSTATUS_MOD_ENABLE;
            BCRCom.BCR_UPDATE_SETTING(ref Result);
            if (Result != BCR_SUCCESS)
            {
                MessageBox.Show("Enable BCR module fail!");
            }
            button4.Enabled = true;
            button3.Enabled = false;
            textBox1.Focus();
        }

        private void button4_Click(object sender, EventArgs e)
        {          
            BCRCom.dwMask_Status = MASK_MODULE_ENABLE;
            BCRCom.dwModuleEnable = BCRSTATUS_MOD_DISABLE;
            BCRCom.BCR_UPDATE_SETTING(ref Result);
            if (Result != BCR_SUCCESS)
            {
                MessageBox.Show("Disable BCR module fail!");
            }
            button3.Enabled = true;
            button4.Enabled = false;
            textBox1.Focus();
        }

        private void button5_Click(object sender, EventArgs e)
        {           
            //event to kill the worker thread
            // Create an AutoReset EventWaitHandle.
            //
            EventWaitHandle hExit = new EventWaitHandle(false, EventResetMode.AutoReset,"Exit");

            hExit.Set();
            this.Close();
            Application.Exit();                 
        }

        private void Form1_Load(object sender, EventArgs e)
        {            
            if (BCRCom.dwModuleEnable == BCRSTATUS_MOD_ENABLE)
            {
                button4.Enabled = true;
                button3.Enabled = false;
            }
            if (BCRCom.dwModuleEnable == BCRSTATUS_MOD_DISABLE)
            {
                button3.Enabled = true;
                button4.Enabled = false;
            }
            if (BCRCom.dwKeyboardHook == BCRSTATUS_HOOK_ON)
            {               
                button2.Enabled = true;
                button1.Enabled = false;
                KeyHook = true;                
            }
            if (BCRCom.dwKeyboardHook == BCRSTATUS_HOOK_OFF)
            {               
                button1.Enabled = true;
                button2.Enabled = false;                
                BCRCom.BCR_READ_COMPORT_DATA();                                  
                Thread newThread = new Thread(new ThreadStart(this.ThreadFunc));             
                newThread.IsBackground = true;
                newThread.Start();
                KeyHook = false;
            }
            if (BCRCom.dwTriggerKey == BCRSTATUS_TK_DEFAULT)
            {
                label5.Text = "Default Button";
            }
            if (BCRCom.dwTriggerKey == BCRSTATUS_TK_START)
            {
                label5.Text = "Start Button";
            }
            if (BCRCom.dwTriggerKey == BCRSTATUS_TK_OK)
            {
                label5.Text = "OK Button";
            }
            this.KeyPreview = true;
            this.Focus();
            textBox1.Focus();
        }                  

        private void Form1_KeyUp(object sender, KeyEventArgs e)
        {            
            if (KeyHook == false)
            {

                switch (Convert.ToUInt16(e.KeyCode))
                {
                    case 244:
                        {
                            BCRCom.BCR_TRIGGER(BCR_TRIG_RELEASE);
                        }
                        break;
                    default:
                        break;
                }
            }
            //}         
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            if (KeyHook == false)
            {
                switch (Convert.ToUInt16(e.KeyCode))
                {
                    case 244:
                        {
                            BCRCom.BCR_TRIGGER(BCR_TRIG_PRESS);
                        }
                        break;
                    default:
                        break;
                }
            }           
        }
        public void UpdateData(object sender, EventArgs e)
        {            
            this.textBox1.Text = BCRCom.GetComPortData;
            this.textBox1.Invalidate();
        }
        private void ThreadFunc()
        {
            //event to kill the thread
            EventWaitHandle hQuit = new Form1.EventWaitHandle(false,
                EventResetMode.AutoReset, "Exit");
            //Set up the named events.
            EventWaitHandle hConnected = new EventWaitHandle(false,
                 EventResetMode.AutoReset, "BCRReadData");           
           
            while (true)
            {
                try
                {                                                            
                    int eventIndex = EventWaitHandle.WaitAny(new WaitHandle[] {
                        hQuit, hConnected });
                   
                    switch (eventIndex)
                    {
                        case 0:
                            //event to kill the thread
                            Console.WriteLine("[kill thread]");
                            return;
                        case 1:                           
                            textBox1.Invoke(new EventHandler(UpdateData));                            
                            break;
                      
                    }
                }
                catch (ThreadAbortException e)
                {
                    Console.WriteLine("Thread - caught ThreadAbortException - resetting.");
                    Console.WriteLine("Exception message: {0}", e.Message);                    
                }

            }         
        }

        internal static class NativeMethods
        {
            internal enum EVENT
            {
                PULSE = 1,
                RESET = 2,
                SET = 3,
            }

            [DllImport("coredll", SetLastError = true)]
            [return: MarshalAs(UnmanagedType.Bool)]
            internal static extern bool EventModify(IntPtr hEvent, EVENT ef);

            [DllImport("coredll", SetLastError = true)]
            internal static extern IntPtr CreateEvent(IntPtr lpEventAttributes,
            bool bManualReset, bool bInitialState, string lpName);

            [DllImport("coredll", SetLastError = true)]
            [return: MarshalAs(UnmanagedType.Bool)]
            internal static extern bool CloseHandle(IntPtr hObject);

            [DllImport("coredll", SetLastError = true)]
            internal static extern int WaitForSingleObject(IntPtr hHandle,
                int dwMilliseconds);

            [DllImport("coredll", SetLastError = true)]
            internal static extern int WaitForMultipleObjects(int nCount,
                IntPtr[] lpHandles, bool fWaitAll, int dwMilliseconds);

        }

        public class EventWaitHandle : WaitHandle
        {
            public const int WaitTimeout = 0x102;

            public EventWaitHandle(bool initialState, EventResetMode mode,
                string name)
            {
                this.Handle = NativeMethods.CreateEvent(IntPtr.Zero,
                     mode == EventResetMode.ManualReset, initialState, name);
            }

            public bool Set()
            {
                return NativeMethods.EventModify(this.Handle,
                    NativeMethods.EVENT.SET);
            }

            public bool Reset()
            {
                return NativeMethods.EventModify(this.Handle,
                    NativeMethods.EVENT.RESET);
            }

            public static int WaitAny(WaitHandle[] waitHandles)
            {
                return WaitAny(waitHandles, Timeout.Infinite, false);
            }

            public static int WaitAny(WaitHandle[] waitHandles,
                int millisecondsTimeout, bool exitContext)
            {
                IntPtr[] handles = new IntPtr[waitHandles.Length];
                for (int i = 0; i < handles.Length; i++)
                {
                    handles[i] = waitHandles[i].Handle;
                }

                return NativeMethods.WaitForMultipleObjects(handles.Length,
                    handles, false, millisecondsTimeout);
            }


            public override bool WaitOne()
            {
                return WaitOne(Timeout.Infinite, false);
            }

            public override bool WaitOne(int millisecondsTimeout, bool exitContext)
            {
                return NativeMethods.WaitForSingleObject(this.Handle,
                    millisecondsTimeout) == 0;
            }

            public override void Close()
            {
                if (this.Handle != WaitHandle.InvalidHandle)
                {
                    NativeMethods.CloseHandle(this.Handle);
                    this.Handle = WaitHandle.InvalidHandle;
                }
            }
        }

        public enum EventResetMode
        {
            AutoReset = 0,
            ManualReset = 1,
        }

        
        
    }
}