//Modify date: 2008/01/10
//Purpose : Set trigger key of the BCR module
//Method:
//          (1) Call BCRCom.BCR_UPDATE_SETTING(ref Result) by setting
//                "BCRCom.dwMask_Status" as 
//                MASK_TRIGGER_KEY = 0x0008
//                "BCRCom.dwTriggerKey" as
//                 BCRSTATUS_TK_START = 5
//                return error code "Result"
//          (2) Call BCRCom.BCR_TRIGGER(BCR_TRIG_PRESS) for registry trigger key
//                where BCR_TRIG_PRESS = 2
//                Call BCRCom.BCR_TRIGGER(BCR_TRIG_RELEASE) for release trigger key
//                where BCR_TRIG_RELEASE = 1
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BCRServiceCOMLib;

namespace SetTriggerkey
{
    public partial class Form1 : Form
    {
        BCRServiceCOMLib.BCRClass BCRCom = new BCRServiceCOMLib.BCRClass();
        public Form1()
        {
            InitializeComponent();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            uint MASK_TRIGGER_KEY = 0x0008;
            uint MASK_KEYHOOK_EMABLE = 0x0080;
            uint BCRSTATUS_TK_START = 5;
            uint BCRSTATUS_HOOK_ON = 2;
            uint Result = 0;
            uint BCR_SUCCESS = 1;            
            BCRCom.dwMask_Status = MASK_KEYHOOK_EMABLE;
            BCRCom.dwKeyboardHook = BCRSTATUS_HOOK_ON;
            BCRCom.BCR_UPDATE_SETTING(ref Result);
            if (Result != BCR_SUCCESS)
            {
                MessageBox.Show("Enable Keyboard Hook fail");
            }           
            BCRCom.dwMask_Status = MASK_TRIGGER_KEY;
            BCRCom.dwTriggerKey = BCRSTATUS_TK_START;
            BCRCom.BCR_UPDATE_SETTING(ref Result);
            if (Result == BCR_SUCCESS)
            {
                MessageBox.Show("Setting TriggerKey Success!");
            }
            else
            {
                MessageBox.Show("Setting Triggerkey fail");
            }          
        }               
    }
}