// GetAllParameterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GetAllParameter.h"
#include "GetAllParameterDlg.h"
#include <winioctl.h>
#include "..\..\..\Inc\BCRService.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif
#define ServiceName L"BCR0:"
#define MAX_EDIT_BUF_SIZE (0x6400000)
#define EDIT_BUF_SIZE (0x63FE000)
#define EDIT_BUF_DEC_SIZE (0x2000)

// CGetAllParameterDlg dialog
int iLen = 0;
volatile static int isUsed=0;
HANDLE hService = NULL;

CGetAllParameterDlg::CGetAllParameterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetAllParameterDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGetAllParameterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CGetAllParameterDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_GET_BTN, &CGetAllParameterDlg::OnBnClickedGetBtn)
END_MESSAGE_MAP()


// CGetAllParameterDlg message handlers

BOOL CGetAllParameterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	hService = CreateFile(ServiceName,GENERIC_READ | GENERIC_WRITE,	0,	NULL,	OPEN_EXISTING,	0,	0);			
	if ( hService == INVALID_HANDLE_VALUE ) 
    {		
		AfxMessageBox ( _T("Creat BCR Service Error!"));
		return FALSE;
    }
	SendDlgItemMessage(IDC_SIZE_EDT,WM_SETTEXT,0,(LPARAM)L"11235");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CGetAllParameterDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	DRA::RelayoutDialog(
		AfxGetInstanceHandle(), 
		this->m_hWnd, 
		DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_GETALLPARAMETER_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_GETALLPARAMETER_DIALOG));
}
#endif


void CGetAllParameterDlg::OnBnClickedGetBtn()
{
	// TODO: Add your control notification handler code here
	TCHAR szString[10];
	TCHAR szMsg[100];
	sBCR_Param_Buff ParamOut;
	unsigned char *pRawParamBuff = NULL;	
	DWORD dwRet = 0;
	GetDlgItemText(IDC_SIZE_EDT, szString, 10);
	iLen = _wtoi(szString);		
	pRawParamBuff = new BYTE[iLen];
	if(pRawParamBuff == NULL)
	{		
		AfxMessageBox ( _T("Create RAM buffer fail!!"));
		return;
	}
	CButton *pCButton;
    pCButton = (CButton *)GetDlgItem(IDC_GET_BTN); 
	pCButton->EnableWindow(FALSE);

	ParamOut.dwBuffLen = iLen;
	ParamOut.pBuff = pRawParamBuff;
	ParamOut.bSuccess = FALSE;
	DeviceIoControl(hService, BCR_IOCTL_GET_ALL_PARAMETERS, NULL, 0, &ParamOut, sizeof(ParamOut), &dwRet, NULL);
	
	RETAILMSG(1, (TEXT(" Get Parameter Size :%d, State :%x!\n"), ParamOut.dwBuffLen, ParamOut.bSuccess));
	
	if( ParamOut.bSuccess){			
		wchar_t* pstrConverted;
		pstrConverted = new TCHAR[ParamOut.dwBuffLen];
		mbstowcs( pstrConverted, (const char *)ParamOut.pBuff , ParamOut.dwBuffLen);		
		EB_Printf(pstrConverted,ParamOut.dwBuffLen);		
		delete[] pstrConverted;
	}	
	else{
		wsprintf(szMsg,L"Must create RAM buffer size = %d",ParamOut.dwBuffLen);
		MessageBox(szMsg,L"Error",MB_OK|MB_ICONERROR);
	}
	delete[] pRawParamBuff;
	pCButton->EnableWindow(TRUE);
}


void CGetAllParameterDlg::OnOK()
{
	CloseHandle(hService);
	PostQuitMessage(0);
}


void CGetAllParameterDlg::EB_Printf(TCHAR *fmt,DWORD dwLen)
{
	wchar_t* string;
	string = new TCHAR[dwLen];

	wchar_t* string2;
	string2 = new TCHAR[dwLen];

    va_list ap;
    int i,slen,lineIdx;
    int txtRepStart,txtRepEnd,txtSelEnd;
    static int wasCr=0; //should be static type.	  
    static int prevBSCnt=0;
    int str2Pt=0;
   
    
    while(isUsed==1); //EB_Printf can be called multiplely  //KIW

    txtRepStart=SendDlgItemMessage(IDC_BUFFER_EDT,WM_GETTEXTLENGTH,0x0,0x0);
    txtRepEnd=txtRepStart-1;
    
    va_start(ap,fmt);
    _vsntprintf(string2,dwLen-1,fmt,ap);
    va_end(ap);

    string2[dwLen-1]='\0';
    
    //for better look of BS(backspace) char.,
    //the BS in the end of the string will be processed next time.
    for(i=0;i<prevBSCnt;i++) //process the previous BS char.
	string[i]='\b';
    string[prevBSCnt]='\0';
    lstrcat(string,string2);
    string2[0]='\0';

    slen=lstrlen(string);
    for(i=0;i<slen;i++)
    	if(string[slen-i-1]!='\b')break;
    
    prevBSCnt=i; // These BSs will be processed next time.
    slen=slen-prevBSCnt;
    
    if(slen==0){
		isUsed=0;
		return;
    }

    for(i=0;i<slen;i++){
		if( (string[i]=='\n')){
			string2[str2Pt++]='\r';txtRepEnd++;
			string2[str2Pt++]='\n';txtRepEnd++;
			wasCr=0;
			continue;
		}
		if( (string[i]!='\n') && (wasCr==1) ){
			string2[str2Pt++]='\r';txtRepEnd++;
			string2[str2Pt++]='\n';txtRepEnd++;
			wasCr=0;
		}
		if(string[i]=='\r'){
			wasCr=1;
			continue;
		}

		if(string[i]=='\b'){
			//flush string2
			if(str2Pt>0){
				string2[--str2Pt]='\0';
				txtRepEnd--;
				continue;
			}			
			if(txtRepStart>0){
				txtRepStart--;		
			}
			continue;
		}
		string2[str2Pt++]=string[i];
		txtRepEnd++;	
    }
    
    string2[str2Pt]='\0';    
    if(str2Pt>0){
		SendDlgItemMessage(IDC_BUFFER_EDT,EM_SETSEL,txtRepStart,txtRepEnd+1);
		SendDlgItemMessage(IDC_BUFFER_EDT,EM_REPLACESEL,0,(LPARAM)string2);         
    }
    else{
		if(txtRepStart<=txtRepEnd){
			SendDlgItemMessage(IDC_BUFFER_EDT,EM_SETSEL,txtRepStart,txtRepEnd+1);
			SendDlgItemMessage(IDC_BUFFER_EDT,EM_REPLACESEL,0,(LPARAM)"");         
		}
    }
	
    
    //If edit buffer is over EDIT_BUF_SIZE,
    //the size of buffer must be decreased by EDIT_BUF_DEC_SIZE.
    if(txtRepEnd>EDIT_BUF_SIZE){
        lineIdx=SendDlgItemMessage(IDC_BUFFER_EDT,EM_LINEFROMCHAR,EDIT_BUF_DEC_SIZE,0x0);
        txtSelEnd=SendDlgItemMessage(IDC_BUFFER_EDT,EM_LINEINDEX,lineIdx,0x0)-1;
		SendDlgItemMessage(IDC_BUFFER_EDT,EM_SETSEL,0,txtSelEnd+1);	
		SendDlgItemMessage(IDC_BUFFER_EDT,EM_REPLACESEL,0,(LPARAM)"");	
		//make the end of the text shown.
		txtRepEnd=SendDlgItemMessage(IDC_BUFFER_EDT,WM_GETTEXTLENGTH,0x0,0x0)-1;
		SendDlgItemMessage(IDC_BUFFER_EDT,EM_SETSEL,txtRepEnd+1,txtRepEnd+2); 
		SendDlgItemMessage(IDC_BUFFER_EDT,EM_REPLACESEL,0,(LPARAM)" ");
		SendDlgItemMessage(IDC_BUFFER_EDT,EM_SETSEL,txtRepEnd+1,txtRepEnd+2); 
		SendDlgItemMessage(IDC_BUFFER_EDT,EM_REPLACESEL,0,(LPARAM)"");
	}
    isUsed=0;
}