// ReadComPortData.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "ReadComPortData.h"
#include <windows.h>
#include <commctrl.h>
#include <winioctl.h>
#include "BCRService.h"
#define MAX_LOADSTRING 100
#define ServiceName L"BCR0:"
// Global Variables:
HINSTANCE			g_hInst;			// current instance
HWND				g_hWndMenuBar;		// menu bar handle
HANDLE		hGoodDecodeEVT = NULL;
LPTSTR TriggerKey;
TCHAR Event_Name[32];
sBCR_Status g_BCR_Status_AP;
// Forward declarations of functions included in this code module:
ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK DlgMain(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL InWideMode();
void ReadMoudleInfo();
BOOL EDHook(HWND hDlg,int Flag);
DWORD WINAPI ThreadWaitGoodEvent( LPVOID lpParameter );

BOOL CreateBCRThread(HWND hDlg);

BOOL GetEventName(HWND hDlg);

HANDLE hService = INVALID_HANDLE_VALUE;
void EB_Printf(TCHAR *fmt,...);
HWND hwInput_edt;
HANDLE hReadGoodThread;
#define MAX_EDIT_BUF_SIZE (0x6400000)
#define EDIT_BUF_SIZE (0x63FE000)
#define EDIT_BUF_DEC_SIZE (0x2000)
int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	MSG msg;

	// Perform application initialization:
	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_READCOMPORTDATA));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_READCOMPORTDATA));
	wc.hCursor       = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;
    TCHAR szTitle[MAX_LOADSTRING];		// title bar text
    TCHAR szWindowClass[MAX_LOADSTRING];	// main window class name

    g_hInst = hInstance; // Store instance handle in our global variable

    // SHInitExtraControls should be called once during your application's initialization to initialize any
    // of the device specific controls such as CAPEDIT and SIPPREF.
    SHInitExtraControls();

    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
    LoadString(hInstance, IDC_READCOMPORTDATA, szWindowClass, MAX_LOADSTRING);

    //If it is already running, then focus on the window, and exit
    hWnd = FindWindow(szWindowClass, szTitle);	
    if (hWnd) 
    {
        // set focus to foremost child window
        // The "| 0x00000001" is used to bring any owned windows to the foreground and
        // activate them.
        SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
        return 0;
    } 

    if (!MyRegisterClass(hInstance, szWindowClass))
    {
    	return FALSE;
    }

    hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

    if (!hWnd)
    {
        return FALSE;
    }

   

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);


    return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;

    static SHACTIVATEINFO s_sai;
	
    switch (message) 
    {
        case WM_COMMAND:
            wmId    = LOWORD(wParam); 
            wmEvent = HIWORD(wParam); 
            // Parse the menu selections:
            switch (wmId)
            {
                case IDM_HELP_ABOUT:
                    DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, About);
                    break;
                case IDM_OK:
                    SendMessage (hWnd, WM_CLOSE, 0, 0);				
                    break;
                default:
                    return DefWindowProc(hWnd, message, wParam, lParam);
            }
            break;
        case WM_CREATE:
            SHMENUBARINFO mbi;

            memset(&mbi, 0, sizeof(SHMENUBARINFO));
            mbi.cbSize     = sizeof(SHMENUBARINFO);
            mbi.hwndParent = hWnd;
            mbi.nToolBarId = IDR_MENU;
            mbi.hInstRes   = g_hInst;

            if (!SHCreateMenuBar(&mbi)) 
            {
                g_hWndMenuBar = NULL;
            }
            else
            {
                g_hWndMenuBar = mbi.hwndMB;
            }

            // Initialize the shell activate info structure
            memset(&s_sai, 0, sizeof (s_sai));
            s_sai.cbSize = sizeof (s_sai);
			DialogBox(g_hInst, (LPCTSTR)IDD_DLG_MAIN, NULL, DlgMain);
            break;
        case WM_PAINT:
            hdc = BeginPaint(hWnd, &ps);
            
            // TODO: Add any drawing code here...
            
            EndPaint(hWnd, &ps);
            break;
        case WM_DESTROY:
            CommandBar_Destroy(g_hWndMenuBar);
            PostQuitMessage(0);
            break;

        case WM_ACTIVATE:
            // Notify shell of our activate message
            SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
            break;
        case WM_SETTINGCHANGE:
            SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
            break;

        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_INITDIALOG:
            {
                // Create a Done button and size it.  
                SHINITDLGINFO shidi;
                shidi.dwMask = SHIDIM_FLAGS;
                shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
                shidi.hDlg = hDlg;
                SHInitDialog(&shidi);
            }
            return (INT_PTR)TRUE;

        case WM_COMMAND:
            if (LOWORD(wParam) == IDOK)
            {
                EndDialog(hDlg, LOWORD(wParam));
                return TRUE;
            }
            break;

        case WM_CLOSE:
            EndDialog(hDlg, message);
            return TRUE;

#ifdef _DEVICE_RESOLUTION_AWARE
        case WM_SIZE:
            {
		DRA::RelayoutDialog(
			g_hInst, 
			hDlg, 
			DRA::GetDisplayMode() != DRA::Portrait ? MAKEINTRESOURCE(IDD_ABOUTBOX_WIDE) : MAKEINTRESOURCE(IDD_ABOUTBOX));
            }
            break;
#endif
    }
    return (INT_PTR)FALSE;
}







// Message handler for Main box.
INT_PTR CALLBACK DlgMain(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	
//	HCURSOR hOldCursor;
	DWORD Result, Result1,ExitCode;
	static HWND hwTrig,hwTrig1,hweventname_edt,hweventname_lbl;
	static HWND hwEhook_btn,hwDhook_btn,hwVersion_lbl,hwEPower_btn,hwDPower_btn;	
	SHORT nState;
	static DWORD BCR_PRESS = BCR_TRIG_PRESS;
	static DWORD BCR_RELEASE = BCR_TRIG_RELEASE;
	hwInput_edt = GetDlgItem(hDlg,IDC_EDIT_INPUT ); 
	hwTrig1 = GetDlgItem( hDlg, IDC_STATIC_TRIGGER1 );
	hwTrig = GetDlgItem( hDlg, IDC_STATIC_TRIGGER );
	hweventname_edt = GetDlgItem( hDlg, IDC_STATIC_EVENTNAME1 );
	hweventname_lbl = GetDlgItem( hDlg, IDC_STATIC_EVENTNAME );

	hwEhook_btn = GetDlgItem( hDlg, IDC_BTN_EHOOK );
	hwDhook_btn = GetDlgItem( hDlg, IDC_BTN_DHOOK );
	hwEPower_btn = GetDlgItem( hDlg, IDC_BTN_EPOWER );
	hwDPower_btn = GetDlgItem( hDlg, IDC_BTN_DPOWER );

	 switch (message)
    {
        case WM_INITDIALOG:
            {
                // Create a Done button and size it.  
                SHINITDLGINFO shidi;
                shidi.dwMask = SHIDIM_FLAGS;
                shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
                shidi.hDlg = hDlg;
                SHInitDialog(&shidi);

				hService = CreateFile(ServiceName,GENERIC_READ | GENERIC_WRITE,	0,	NULL,	OPEN_EXISTING,	0,	0);			
				ReadMoudleInfo();
				SendMessage(hweventname_edt,WM_SETTEXT,0,(LPARAM)"");		
						
				if(g_BCR_Status_AP.dwModuleEnable == BCRSTATUS_MOD_ENABLE){
					EnableWindow(hwEPower_btn,FALSE);				
					EnableWindow(hwDPower_btn,TRUE);
				}
				if(g_BCR_Status_AP.dwModuleEnable == BCRSTATUS_MOD_DISABLE){
					EnableWindow(hwEPower_btn,TRUE);
					EnableWindow(hwDPower_btn,FALSE);
				}
				if(g_BCR_Status_AP.dwKeyboardHook == BCRSTATUS_HOOK_ON){
					EnableWindow(hwDhook_btn,TRUE);
					EnableWindow(hwEhook_btn,FALSE);
				}
				if(g_BCR_Status_AP.dwKeyboardHook == BCRSTATUS_HOOK_OFF){
					EnableWindow(hwEhook_btn,TRUE);				
					EnableWindow(hwDhook_btn,FALSE);
					GetEventName(hDlg);	
					SendMessage(hweventname_edt,WM_SETTEXT,0,(LPARAM)Event_Name);		
					CreateBCRThread(hDlg);
				}
		
				switch(g_BCR_Status_AP.dwTriggerKey){
					case BCRSTATUS_TK_DEFAULT:
						{							
							if( ! RegisterHotKey(hDlg,OEM_VK_BCR_TRIGGER,MOD_KEYUP,OEM_VK_BCR_TRIGGER))
							::MessageBox( NULL, _T("ERROR registring Default key"), _T("ERROR"), MB_TOPMOST | MB_OK );

							TriggerKey = L"Default Button";		
							SendMessage(hwTrig1,WM_SETTEXT,0,(LPARAM)TriggerKey);						
							
						}
						break;
					case BCRSTATUS_TK_OK:
						{							
							if( ! RegisterHotKey(hDlg,OEM_VK_BCR_TRIGGER,MOD_KEYUP,OEM_VK_BCR_TRIGGER))
							::MessageBox( NULL, _T("ERROR registring AP(OK) button"), _T("ERROR"), MB_TOPMOST | MB_OK );

							TriggerKey = L"OK Button";		
							SendMessage(hwTrig1,WM_SETTEXT,0,(LPARAM)TriggerKey);						
							
						}
						break;					
					case BCRSTATUS_TK_START:
						{							
							if( ! RegisterHotKey(hDlg,OEM_VK_BCR_TRIGGER,MOD_KEYUP,OEM_VK_BCR_TRIGGER))
							::MessageBox( NULL, _T("ERROR registring AP(OK) button"), _T("ERROR"), MB_TOPMOST | MB_OK );

							TriggerKey = L"Start Button";		
							SendMessage(hwTrig1,WM_SETTEXT,0,(LPARAM)TriggerKey);						
							
						}
						break;		
				}
			}
			break;
		 case WM_COMMAND:
            if (LOWORD(wParam) == IDOK)
            {	
				PostQuitMessage(0);
			}	
			if (LOWORD(wParam) == IDC_BUTTON1)
            {	
				MessageBox(hDlg,L"1",L"1",MB_OK|MB_APPLMODAL);		
				Sleep(300);
				HWND hnd = FindWindow(NULL,L"1");	
				DestroyWindow(hnd);
			}	
		
			
			if (LOWORD(wParam) == IDC_BTN_EHOOK){
				if (EDHook(hDlg,1)==TRUE){												    	
						EnableWindow(hwDhook_btn,TRUE);
						EnableWindow(hwEhook_btn,FALSE);
						SendMessage(hweventname_edt,WM_SETTEXT,0,(LPARAM)"");	
						g_BCR_Status_AP.dwMask = MASK_KEYHOOK_EMABLE;
						g_BCR_Status_AP.dwKeyboardHook = BCRSTATUS_HOOK_ON;                                 
						DeviceIoControl(hService, BCR_IOCTL_UPDATE_SETTING, &g_BCR_Status_AP, sizeof(g_BCR_Status_AP), &Result, sizeof(DWORD), NULL, NULL);     
						if (Result !=1 ){		
								RETAILMSG(1,(TEXT("Enable Keyboard Hook fail,Error Code:%d"),Result));
						}					
						GetExitCodeThread(hReadGoodThread,&ExitCode);
						TerminateThread( hReadGoodThread,ExitCode ); 	
				}
                return TRUE;
            }
			if (LOWORD(wParam) == IDC_BTN_DHOOK){
				if (EDHook(hDlg,0)==TRUE){																		
							EnableWindow(hwEhook_btn,TRUE);
							EnableWindow(hwDhook_btn,FALSE);
							g_BCR_Status_AP.dwMask = MASK_KEYHOOK_EMABLE;
							g_BCR_Status_AP.dwKeyboardHook = BCRSTATUS_HOOK_OFF;                                 
							DeviceIoControl(hService, BCR_IOCTL_UPDATE_SETTING, &g_BCR_Status_AP, sizeof(g_BCR_Status_AP), &Result, sizeof(DWORD), NULL, NULL);     
							if (Result !=1 ){		
								RETAILMSG(1,(TEXT("Enable Keyboard Hook fail,Error Code:%d"),Result));
							}	
							GetEventName(hDlg);			
							SendMessage(hweventname_edt,WM_SETTEXT,0,(LPARAM)Event_Name);		
							CreateBCRThread(hDlg);
				}
                return TRUE;
            }
			if (LOWORD(wParam) == IDC_BTN_EPOWER){
						EnableWindow(hwDPower_btn,TRUE);
						EnableWindow(hwEPower_btn,FALSE);
						g_BCR_Status_AP.dwMask = MASK_MODULE_ENABLE;	
						g_BCR_Status_AP.dwModuleEnable = BCRSTATUS_MOD_ENABLE;
						if (DeviceIoControl(hService, BCR_IOCTL_UPDATE_SETTING, &g_BCR_Status_AP, sizeof(g_BCR_Status_AP), &Result, sizeof(DWORD), &Result1, NULL)){			
								MessageBox(hDlg,L"Module Enable Command success",L"success",MB_OK|MB_ICONINFORMATION);
						}
						else{			
								MessageBox(hDlg,L"Module Enable Command fail",L"Error",MB_OK|MB_ICONERROR);
								return FALSE;
						}
				
                return TRUE;
            }
			if (LOWORD(wParam) == IDC_BTN_DPOWER){	
						EnableWindow(hwDPower_btn,FALSE);
						EnableWindow(hwEPower_btn,TRUE);
						g_BCR_Status_AP.dwMask = MASK_MODULE_ENABLE;	
						g_BCR_Status_AP.dwModuleEnable = BCRSTATUS_MOD_DISABLE;
						if (DeviceIoControl(hService, BCR_IOCTL_UPDATE_SETTING, &g_BCR_Status_AP, sizeof(g_BCR_Status_AP), &Result, sizeof(DWORD), &Result1, NULL)){			
								MessageBox(hDlg,L"Module Disable Command success",L"success",MB_OK|MB_ICONINFORMATION);
						}
						else{			
								MessageBox(hDlg,L"Module Disable Command fail",L"Error",MB_OK|MB_ICONERROR);
								return FALSE;
						}
                return TRUE;
            }
			break;
	case WM_HOTKEY:
			{								
					  switch (wParam)
						{
								case OEM_VK_BCR_TRIGGER:
									if( hService != INVALID_HANDLE_VALUE ){	
										 nState=GetAsyncKeyState(OEM_VK_BCR_TRIGGER);
										 if (HIBYTE(nState)){
											 DeviceIoControl(hService, BCR_IOCTL_TRIGGER, &BCR_PRESS, sizeof(DWORD), &Result, sizeof(DWORD), &Result1, NULL);																														
										 }
										 else{
											 DeviceIoControl(hService, BCR_IOCTL_TRIGGER, &BCR_RELEASE, sizeof(DWORD), &Result, sizeof(DWORD), &Result1, NULL);																														
										 }										
									}		
									break;								
					  }
			}
			break;
	case WM_SIZE:
			{
				  if (InWideMode() == TRUE){	
				  }
				  else{
					  SetWindowPos(hwInput_edt,NULL,10, 10, 220, 130, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);					  
					  SetWindowPos(hwEhook_btn,NULL,20, 150, 100, 30, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);
					  SetWindowPos(hwDhook_btn,NULL,130, 150, 100, 30, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);
					  SetWindowPos(hwEPower_btn,NULL,20, 190, 100, 30, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);
					  SetWindowPos(hwDPower_btn,NULL,130, 190, 100, 30, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);					  					  
					  SetWindowPos(hwTrig,NULL,10, 220, 70, 20, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);
					  SetWindowPos(hwTrig1,NULL,90, 220, 150, 20, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);
					  SetWindowPos(hweventname_lbl,NULL,10, 240, 70, 20, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);
					  SetWindowPos(hweventname_edt,NULL,90, 240, 100, 20, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);
					  SetWindowPos(hwVersion_lbl,NULL,190, 250, 50, 20, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);					  					  
					  
				  }
			}
			break;
	 }
	return (INT_PTR)FALSE;
}


void ReadMoudleInfo()
{	
 	if( hService != INVALID_HANDLE_VALUE ){		
	    DeviceIoControl(hService, BCR_IOCTL_GET_STATUS, NULL, 0, &g_BCR_Status_AP, sizeof(g_BCR_Status_AP), NULL, NULL);
	}
	else{
		MessageBox(NULL,L"BCR_IOCTL_GET_STATUS Command fail",L"ERROR",MB_OK);	
	}
}


//////////////////////////////////////////////////////////////////////////////
// FUNCTION: InWideMode()
//
BOOL InWideMode()
{
    int height = GetSystemMetrics(SM_CYSCREEN);
	return (height < 320) ? TRUE : FALSE;

}

BOOL GetEventName(HWND hDlg)
{

	DWORD Result1;	
	if( hService != INVALID_HANDLE_VALUE ){	
		if (DeviceIoControl(hService, BCR_IOCTL_GET_EVENTNAME, NULL, 0, Event_Name, sizeof(Event_Name) / sizeof(Event_Name[0]), &Result1, NULL)){	
			int idx;			
			for(idx=0; idx<13; idx++){
				RETAILMSG(1,(TEXT("%c"), (char)(Event_Name[idx])));
			}
			hGoodDecodeEVT = CreateEvent( NULL, TRUE, FALSE, Event_Name );
			if(hGoodDecodeEVT ==NULL){				
				MessageBox(hDlg,L"Create event fail",L"Error",MB_OK);				
				return FALSE;
			}			
		}
		else{
			MessageBox(hDlg,L"GET_EVENT_NAME Command fail",L"ERROR",MB_OK);				
		}
	}	
	return TRUE;
}


BOOL CreateBCRThread(HWND hDlg)
{
	DWORD dwThreadId;
	
	if( hGoodDecodeEVT != NULL )
	{

			hReadGoodThread = CreateThread( NULL, 
							  0,
							  &ThreadWaitGoodEvent,
							  NULL, //reinterpret_cast< void* >( &g_sSerial ),
							  0,
							  &dwThreadId);			

	}
	else
	{
		RETAILMSG(1,(TEXT("No Any Event need to Wait!\r\n")));
		return FALSE;
	}
	return TRUE;
}




DWORD WINAPI ThreadWaitGoodEvent( LPVOID lpParameter )
{
	DWORD dwResult;
	char lpBuffer[4096];
	TCHAR buffer[4096];		
	TCHAR buffer2[4096];	
	char * tpBuf = lpBuffer;
	memset(lpBuffer, 0x0, 4096);
	while(1)
	{
	dwResult = WaitForSingleObject( hGoodDecodeEVT, INFINITE );
		
		if( dwResult == WAIT_OBJECT_0 ){		
			if( hService != INVALID_HANDLE_VALUE ){
				BOOL stat;
				DWORD ByteofRead = 0;
				DWORD SUM_ByteofRead = 0;
				ResetEvent( hGoodDecodeEVT );
				while(1)
				{
					Sleep(200);
					stat = ReadFile( hService, 
								 tpBuf, 
								 100, 
								 &ByteofRead, 
								 NULL
								);
					if( ByteofRead == 0 )
					{
						break;
					}
					else
					{
						tpBuf +=ByteofRead;
						SUM_ByteofRead += ByteofRead;
					}
					Sleep(10);

				}
				{
					DWORD idx;
					int index = 0;
					RETAILMSG(1,(TEXT("[Wind]Receive Data : \r\n")));
					for(idx=0; idx<SUM_ByteofRead; idx++)
					{
						RETAILMSG(1,(TEXT("%c"), (char)(lpBuffer[idx])));
					}
					RETAILMSG(1,(TEXT("\r\n")));
					memset(buffer, 0x0, 4096);
					memset(buffer2, 0x0, 4096);
					mbstowcs( buffer, lpBuffer ,sizeof(lpBuffer));													
					for(idx=0; idx<SUM_ByteofRead; idx++)
					{				
						buffer2[index++] = buffer[idx];
						if(buffer[idx] == 0x0D){																										
							wsprintf(buffer2,L"%s\n",buffer2);					
							EB_Printf(buffer2);															
							ZeroMemory(buffer2,sizeof(buffer2));									
							index = 0;
						}																
					}										
					tpBuf = lpBuffer;
					SUM_ByteofRead = 0;
				}
			}		
		}
		else{
			MessageBox(NULL,L"ThreadWaitGoodEvent With Error",L"Error",MB_OK);					
			break;
		}
	}	
	return 0;
}


BOOL EDHook(HWND hDlg,int Flag)
{

	DWORD Result, Result1;

	if(Flag ==1){
		g_BCR_Status_AP.dwMask = MASK_KEYHOOK_EMABLE;	
		g_BCR_Status_AP.dwKeyboardHook = BCRSTATUS_HOOK_ON;
		if (DeviceIoControl(hService, BCR_IOCTL_UPDATE_SETTING, &g_BCR_Status_AP, sizeof(g_BCR_Status_AP), &Result, sizeof(DWORD), &Result1, NULL)){			
			MessageBox(hDlg,L"KeyBoardHook Enable Command success",L"success",MB_OK|MB_ICONINFORMATION);
		}
		else{			
			MessageBox(hDlg,L"KeyBoardHook Enable Command fail",L"Error",MB_OK|MB_ICONERROR);
			return FALSE;
		}
	}
	if (Flag ==0){
		g_BCR_Status_AP.dwMask = MASK_KEYHOOK_EMABLE;	
		g_BCR_Status_AP.dwKeyboardHook = BCRSTATUS_HOOK_OFF;
		if (DeviceIoControl(hService, BCR_IOCTL_UPDATE_SETTING, &g_BCR_Status_AP, sizeof(g_BCR_Status_AP), &Result, sizeof(DWORD), &Result1, NULL)){		
			MessageBox(hDlg,L"KeyBoardHook Disable Command success",L"success",MB_OK|MB_ICONINFORMATION);
		}
		else{
			MessageBox(hDlg,L"KeyBoardHook Disable Command fail",L"Error",MB_OK|MB_ICONERROR);
			return FALSE;
		}
	}	

	return TRUE;

}


#define STRING_LEN  4096  
volatile static int isUsed=0;


void EB_Printf(TCHAR *fmt,...)
{
    va_list ap;
    int i,slen,lineIdx;
    int txtRepStart,txtRepEnd,txtSelEnd;
    static int wasCr=0; //should be static type.
    static TCHAR string[STRING_LEN+4096]; //margin for '\b'
    static TCHAR string2[STRING_LEN+4096]; //margin for '\n'->'\r\n'
    static int prevBSCnt=0;
    int str2Pt=0;
   
    
    while(isUsed==1); //EB_Printf can be called multiplely  //KIW

    txtRepStart=SendMessage(hwInput_edt,WM_GETTEXTLENGTH,0x0,0x0);
    txtRepEnd=txtRepStart-1;
    
    va_start(ap,fmt);
    _vsntprintf(string2,STRING_LEN-1,fmt,ap);
    va_end(ap);

    string2[STRING_LEN-1]='\0';
    
    //for better look of BS(backspace) char.,
    //the BS in the end of the string will be processed next time.
    for(i=0;i<prevBSCnt;i++) //process the previous BS char.
	string[i]='\b';
    string[prevBSCnt]='\0';
    lstrcat(string,string2);
    string2[0]='\0';

    slen=lstrlen(string);
    for(i=0;i<slen;i++)
    	if(string[slen-i-1]!='\b')break;
    
    prevBSCnt=i; // These BSs will be processed next time.
    slen=slen-prevBSCnt;
    
    if(slen==0)
    {
	isUsed=0;
	return;
    }

    for(i=0;i<slen;i++)
    {
	if( (string[i]=='\n'))
	{
	    string2[str2Pt++]='\r';txtRepEnd++;
	    string2[str2Pt++]='\n';txtRepEnd++;
	    wasCr=0;
	    continue;
	}
	if( (string[i]!='\n') && (wasCr==1) )
	{
	    string2[str2Pt++]='\r';txtRepEnd++;
	    string2[str2Pt++]='\n';txtRepEnd++;
	    wasCr=0;
	}
	if(string[i]=='\r')
	{
	    wasCr=1;
	    continue;
	}

	if(string[i]=='\b')
	{
	    //flush string2
	    if(str2Pt>0)
	    {
		string2[--str2Pt]='\0';
		txtRepEnd--;
		continue;
	    }
	    //str2Pt==0;	    
	    if(txtRepStart>0)
	    {
		txtRepStart--;		
	    }
	    continue;
	}
	string2[str2Pt++]=string[i];
	txtRepEnd++;
	// if(str2Pt>256-3)break; //why needed? 2001.1.26
    }
    
    string2[str2Pt]='\0';    
    if(str2Pt>0)
    {
	SendMessage(hwInput_edt,EM_SETSEL,txtRepStart,txtRepEnd+1);
	SendMessage(hwInput_edt,EM_REPLACESEL,0,(LPARAM)string2);         
    }
    else
    {
	if(txtRepStart<=txtRepEnd)
	{
	SendMessage(hwInput_edt,EM_SETSEL,txtRepStart,txtRepEnd+1);
	SendMessage(hwInput_edt,EM_REPLACESEL,0,(LPARAM)"");         
	}
    }
	
    
    //If edit buffer is over EDIT_BUF_SIZE,
    //the size of buffer must be decreased by EDIT_BUF_DEC_SIZE.
    if(txtRepEnd>EDIT_BUF_SIZE)
    {
        lineIdx=SendMessage(hwInput_edt,EM_LINEFROMCHAR,EDIT_BUF_DEC_SIZE,0x0);
	//lineIdx=SendMessage(_hwndEdit,EM_LINEFROMCHAR,txtRepEnd-txtRepStart+1,0x0); //for debug
        txtSelEnd=SendMessage(hwInput_edt,EM_LINEINDEX,lineIdx,0x0)-1;
	SendMessage(hwInput_edt,EM_SETSEL,0,txtSelEnd+1);
	
	SendMessage(hwInput_edt,EM_REPLACESEL,0,(LPARAM)"");
	//SendMessage(_hwndEdit,WM_CLEAR,0,0); //WM_CLEAR doesn't work? Why?
	//SendMessage(_hwndEdit,WM_CUT,0,0); //WM_CUT doesn't work? Why?

	//make the end of the text shown.
	txtRepEnd=SendMessage(hwInput_edt,WM_GETTEXTLENGTH,0x0,0x0)-1;
	SendMessage(hwInput_edt,EM_SETSEL,txtRepEnd+1,txtRepEnd+2); 
	SendMessage(hwInput_edt,EM_REPLACESEL,0,(LPARAM)" ");
	SendMessage(hwInput_edt,EM_SETSEL,txtRepEnd+1,txtRepEnd+2); 
	SendMessage(hwInput_edt,EM_REPLACESEL,0,(LPARAM)"");
    }

    isUsed=0;
}
