// UpdateFirmware.cpp : Defines the entry point for the application.
//
//Modify date: 2008/01/10
//Purpose : Update BCR module firmware 
//Process:
//		(1) Setting g_BCR_FW_AP.hWnd = hDlg;(set window handle)					    
//		(2) Setting g_BCR_FW_AP.szPassword = L"1234567890AB";
//		(3) Setting g_BCR_FW_AP.szFilePath = L"\\My Documents\\BCR\\Load_FL23J05.BIN";
//		(4)	call BCR_IOCTL_UPDATE_FIRMWARE DeviceIoControl

#include "stdafx.h"
#include "UpdateFirmware.h"
#include <windows.h>
#include <commctrl.h>
#include "..\..\..\Inc\BCRService.h"
#include <winioctl.h>
#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE			g_hInst;			// current instance
HWND				g_hWndMenuBar;		// menu bar handle
#define ServiceName L"BCR0:"
sBCR_FW g_BCR_FW_AP;
sBCR_Status g_BCR_Status_AP;



// Forward declarations of functions included in this code module:
ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
void ReadModuleInfo();
INT_PTR CALLBACK DlgMain(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	MSG msg;

	// Perform application initialization:
	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_UPDATEFIRMWARE));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_UPDATEFIRMWARE));
	wc.hCursor       = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;
    TCHAR szTitle[MAX_LOADSTRING];		// title bar text
    TCHAR szWindowClass[MAX_LOADSTRING];	// main window class name

    g_hInst = hInstance; // Store instance handle in our global variable

    // SHInitExtraControls should be called once during your application's initialization to initialize any
    // of the device specific controls such as CAPEDIT and SIPPREF.
    SHInitExtraControls();

    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
    LoadString(hInstance, IDC_UPDATEFIRMWARE, szWindowClass, MAX_LOADSTRING);

    //If it is already running, then focus on the window, and exit
    hWnd = FindWindow(szWindowClass, szTitle);	
    if (hWnd) 
    {
        // set focus to foremost child window
        // The "| 0x00000001" is used to bring any owned windows to the foreground and
        // activate them.
        SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
        return 0;
    } 

    if (!MyRegisterClass(hInstance, szWindowClass))
    {
    	return FALSE;
    }

    hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

    if (!hWnd)
    {
        return FALSE;
    }
    
    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);


    return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;

    static SHACTIVATEINFO s_sai;
	
    switch (message) 
    {
        case WM_COMMAND:
            wmId    = LOWORD(wParam); 
            wmEvent = HIWORD(wParam); 
            // Parse the menu selections:
            switch (wmId)
            {
                case IDM_HELP_ABOUT:
                    DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, About);
                    break;
                case IDM_OK:
                    SendMessage (hWnd, WM_CLOSE, 0, 0);				
                    break;
                default:
                    return DefWindowProc(hWnd, message, wParam, lParam);
            }
            break;
        case WM_CREATE:
            SHMENUBARINFO mbi;

            memset(&mbi, 0, sizeof(SHMENUBARINFO));
            mbi.cbSize     = sizeof(SHMENUBARINFO);
            mbi.hwndParent = hWnd;
            mbi.nToolBarId = IDR_MENU;
            mbi.hInstRes   = g_hInst;

            if (!SHCreateMenuBar(&mbi)) 
            {
                g_hWndMenuBar = NULL;
            }
            else
            {
                g_hWndMenuBar = mbi.hwndMB;
            }

            // Initialize the shell activate info structure
            memset(&s_sai, 0, sizeof (s_sai));
            s_sai.cbSize = sizeof (s_sai);
			DialogBox(g_hInst, (LPCTSTR)IDD_DLG_MAIN, NULL, DlgMain);
            break;
        case WM_PAINT:
            hdc = BeginPaint(hWnd, &ps);
            
            // TODO: Add any drawing code here...
            
            EndPaint(hWnd, &ps);
            break;
        case WM_DESTROY:
            CommandBar_Destroy(g_hWndMenuBar);
            PostQuitMessage(0);
            break;

        case WM_ACTIVATE:
            // Notify shell of our activate message
            SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
            break;
        case WM_SETTINGCHANGE:
            SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
            break;

        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_INITDIALOG:
            {
                // Create a Done button and size it.  
                SHINITDLGINFO shidi;
                shidi.dwMask = SHIDIM_FLAGS;
                shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
                shidi.hDlg = hDlg;
                SHInitDialog(&shidi);
            }
            return (INT_PTR)TRUE;

        case WM_COMMAND:
            if (LOWORD(wParam) == IDOK)
            {
                EndDialog(hDlg, LOWORD(wParam));
                return TRUE;
            }
            break;

        case WM_CLOSE:
            EndDialog(hDlg, message);
            return TRUE;

#ifdef _DEVICE_RESOLUTION_AWARE
        case WM_SIZE:
            {
		DRA::RelayoutDialog(
			g_hInst, 
			hDlg, 
			DRA::GetDisplayMode() != DRA::Portrait ? MAKEINTRESOURCE(IDD_ABOUTBOX_WIDE) : MAKEINTRESOURCE(IDD_ABOUTBOX));
            }
            break;
#endif
    }
    return (INT_PTR)FALSE;
}



// Message handler for Main box.
INT_PTR CALLBACK DlgMain(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

	DWORD Result;
	HCURSOR hOldCursor;
	TCHAR STR_FW_STATUS1[60] = L"Be comparing the password";
	TCHAR STR_FW_STATUS2[60] = L"Be checking the file of firmware";
	TCHAR STR_FW_STATUS3[60] = L"Be downloading the 2nd loader";
	TCHAR STR_FW_STATUS4[60] = L"Be erasing memory";
	TCHAR STR_FW_STATUS5[60] = L"Be downloading the main program";
	TCHAR STR_FW_STATUS6[60] = L"Represents the downloading progress in percentage";
	TCHAR STR_FW_STATUS7[60] = L"The operation completed successfully.";
	TCHAR STR_FW_STATUS8[60] = L"The parameter is incorrect.";
	TCHAR STR_FW_STATUS9[60] = L"The password is incorrect.";
	TCHAR STR_FW_STATUS10[60] = L"Failed to open the file of firmware.";
	TCHAR STR_FW_STATUS11[60] = L"The content of firmware is invalid.";
	TCHAR STR_FW_STATUS12[60] = L"Failed to download the 2nd loader.";
	TCHAR STR_FW_STATUS13[60] = L"Memory erasion is failed.";
	TCHAR STR_FW_STATUS14[60] = L"Failed to download the main program.";
	TCHAR STR_FW_STATUS15[60] = L"The operation was canceled by the user";
	TCHAR STR_FW_STATUS16[60] = L"The barcode reader module type is unknown.";
	TCHAR szPercent[MAX_PATH];
	static	HWND hwInStatus_lbl,hw100_lbl;

	hwInStatus_lbl = GetDlgItem(hDlg,IDC_STATIC_INFWSTATUS ); 
	hw100_lbl = GetDlgItem(hDlg,IDC_STATIC_100 ); 	

	 switch (message)
    {
        case WM_INITDIALOG:
            {
                // Create a Done button and size it.  
                SHINITDLGINFO shidi;
                shidi.dwMask = SHIDIM_FLAGS;
                shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
                shidi.hDlg = hDlg;
                SHInitDialog(&shidi);

		
			}
		 case WM_COMMAND:
            if (LOWORD(wParam) == IDOK)
            {	
				PostQuitMessage(0);
			}			
		    if (LOWORD(wParam) == IDC_UPFW_BTN)
            {	
					hOldCursor = SetCursor( LoadCursor( g_hInst, IDC_WAIT));
					HANDLE hService = CreateFile(ServiceName,GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,0);			
					if( hService != INVALID_HANDLE_VALUE ){		
						g_BCR_FW_AP.hWnd = hDlg;					    
						lstrcpy(g_BCR_FW_AP.szPassword,L"1234567890AB");						      
						lstrcpy(g_BCR_FW_AP.szFilePath,L"\\My Documents\\BCR\\Load_FL23J05.BIN");						      
						DeviceIoControl(hService, BCR_IOCTL_UPDATE_FIRMWARE, &g_BCR_FW_AP, sizeof(g_BCR_FW_AP), &Result, sizeof(DWORD), NULL, NULL);							
						if (Result != BCR_SUCCESS ){		
								RETAILMSG(1,(TEXT("Update Fireware fail,Error Code:%d"),Result));
								MessageBox(hDlg,L"Update Fireware fail",L"Error",MB_OK);
						}
						SetTimer( hDlg, 1, 10000, NULL );                                         
					}
					CloseHandle(hService);
					SetCursor( hOldCursor );	
			}			
			 if (LOWORD(wParam) == IDC_CANCEL_BTN)
            {	
					// Cancel Button
					g_BCR_FW_AP.hWnd = hDlg;
					HANDLE hService = CreateFile(ServiceName,GENERIC_READ | GENERIC_WRITE,	0,	NULL,	OPEN_EXISTING,	0,	0);			
					if( hService != INVALID_HANDLE_VALUE ){		
						DeviceIoControl(hService, BCR_IOCTL_CANCEL_UPDATE, &g_BCR_FW_AP, sizeof(g_BCR_FW_AP), &Result, sizeof(DWORD),NULL, NULL);							
					}
					CloseHandle(hService);
			}			
			break;				
		case BCR_FWUPD_CMP_PWD:
			{									
				SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS1);						
			}
			break;
		case BCR_FWUPD_CHK_FILE:
			{			
				SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS2);						
			}
			break;
		case BCR_FWUPD_DWNLD_2ND_LDR:
			{
				SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS3);						
			}
			break;
		case BCR_FWUPD_ERASE_MEMORY:
			{				
				SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS4);						
			}
			break;
		case BCR_FWUPD_DWNLD_MAIN_PROG:
			{				
				SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS5);						
			}
			break;
		case BCR_FWUPD_PROGRESS:
			{				
				wsprintf(szPercent,L"%d",LOWORD(wParam)); 								
				SendMessage(hw100_lbl,WM_SETTEXT,0,(LPARAM)szPercent);						
				SendDlgItemMessage(hDlg, IDC_PROGRESS_FW, PBM_SETPOS, 0, 0);
				SendDlgItemMessage(hDlg, IDC_PROGRESS_FW, PBM_SETSTEP,(LPARAM)LOWORD(wParam), 0);
				SendDlgItemMessage(hDlg, IDC_PROGRESS_FW, PBM_STEPIT, 0, 0);
				SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS6);					
			}
			break;
		case BCR_FWUPD_RESULT:
			{
				ReadModuleInfo();
				KillTimer(hDlg,1);
				if (LOWORD(wParam)==FWUPD_SUCCESS){												
					SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS7);						
					SetWindowText(GetDlgItem(hDlg,IDC_UPFW_BTN ),L"Start");		
					MessageBox(hDlg,STR_FW_STATUS7,L"Success",MB_OK|MB_ICONINFORMATION);									
				}
				if (LOWORD(wParam)==FWUPD_INVALID_PARAMETER){									
					SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS8);						
					SetWindowText(GetDlgItem(hDlg,IDC_UPFW_BTN ),L"Start");			
					MessageBox(hDlg,STR_FW_STATUS8,L"Error",MB_OK|MB_ICONERROR);						
				}
				if (LOWORD(wParam)==FWUPD_WRONG_PASSWORD){										
					SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS9);						
					SetWindowText(GetDlgItem(hDlg,IDC_UPFW_BTN ),L"Start");		
					MessageBox(hDlg,STR_FW_STATUS9,L"Error",MB_OK|MB_ICONERROR);					
				}
				if (LOWORD(wParam)==FWUPD_FILE_OPEN_FAILED){												
					SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS10);
					SetWindowText(GetDlgItem(hDlg,IDC_UPFW_BTN ),L"Start");		
					MessageBox(hDlg,STR_FW_STATUS10,L"Error",MB_OK|MB_ICONERROR);										
				}
				if (LOWORD(wParam)==FWUPD_INVALID_FIRMWARE){													
					SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS11);	
					SetWindowText(GetDlgItem(hDlg,IDC_UPFW_BTN ),L"Start");		
					MessageBox(hDlg,STR_FW_STATUS11,L"Error",MB_OK|MB_ICONERROR);									
				}
				if (LOWORD(wParam)==FWUPD_DWNLD_2ND_LDR_FAILED){					
					SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS12);	
					SetWindowText(GetDlgItem(hDlg,IDC_UPFW_BTN ),L"Start");		
					MessageBox(hDlg,STR_FW_STATUS12,L"Error",MB_OK|MB_ICONERROR);										
				}
				if (LOWORD(wParam)==FWUPD_ERASE_MEMORY_FAILED){												
					SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS13);	
					SetWindowText(GetDlgItem(hDlg,IDC_UPFW_BTN ),L"Start");		
					MessageBox(hDlg,STR_FW_STATUS13,L"Error",MB_OK|MB_ICONERROR);										
				}
				if (LOWORD(wParam)==FWUPD_DWNLD_MAIN_PROG_FAILED){												
					SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS14);	
					SetWindowText(GetDlgItem(hDlg,IDC_UPFW_BTN ),L"Start");	
					MessageBox(hDlg,STR_FW_STATUS14,L"Error",MB_OK|MB_ICONERROR);					
				}
				if (LOWORD(wParam)==FWUPD_CANCELLED){												
					SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS15);	
					SetWindowText(GetDlgItem(hDlg,IDC_UPFW_BTN ),L"Start");		
					MessageBox(hDlg,STR_FW_STATUS15,L"Error",MB_OK|MB_ICONERROR);										
				}							
				if (LOWORD(wParam)==FWUPD_UNKNOWN_MODULE_TYPE){												
					SendMessage(hwInStatus_lbl,WM_SETTEXT,0,(LPARAM)STR_FW_STATUS16);	
					SetWindowText(GetDlgItem(hDlg,IDC_UPFW_BTN ),L"Start");		
					MessageBox(hDlg,STR_FW_STATUS16,L"Error",MB_OK|MB_ICONERROR);										
				}	
									
			}
			break;
		case WM_TIMER:
			if( wParam == 1 )
			{
					SystemIdleTimerReset();
			}
			break;
	 }
	return (INT_PTR)FALSE;
}
// Read BCR Module Informatin 
void ReadModuleInfo()
{
	HANDLE hService = CreateFile(ServiceName,GENERIC_READ | GENERIC_WRITE,	0,	NULL,	OPEN_EXISTING,	0,	0);			
 	if( hService != INVALID_HANDLE_VALUE ){		
	    DeviceIoControl(hService, BCR_IOCTL_GET_STATUS, NULL, 0, &g_BCR_Status_AP, sizeof(g_BCR_Status_AP), NULL, NULL);		
		CloseHandle(hService);
	}
	
}
