// BattBrightness.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "BattBrightness.h"
#include <windows.h>
#include <commctrl.h>

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE			g_hInst;			// current instance
HWND				g_hWndMenuBar;		// menu bar handle
#define REGKEY					TEXT("ControlPanel\\Backlight")
#define BRIGHTNESS				TEXT("Brightness")
#define ACBRIGHTNESS			TEXT("ACBrightness")
#define eBrightness 0
#define ACBrightness 1
// Forward declarations of functions included in this code module:
ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

INT_PTR CALLBACK DlgMain(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
HRESULT SetToRegistry(HWND hDlg,DWORD eVal,DWORD dwValueChecked);
void ChangeBacklight();
HRESULT GetFromRegistry(HWND hDlg, DWORD *pdwValueChecked);
int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	MSG msg;

	// Perform application initialization:
	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_BATTBRIGHTNESS));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_BATTBRIGHTNESS));
	wc.hCursor       = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;
    TCHAR szTitle[MAX_LOADSTRING];		// title bar text
    TCHAR szWindowClass[MAX_LOADSTRING];	// main window class name

    g_hInst = hInstance; // Store instance handle in our global variable

    // SHInitExtraControls should be called once during your application's initialization to initialize any
    // of the device specific controls such as CAPEDIT and SIPPREF.
    SHInitExtraControls();

    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
    LoadString(hInstance, IDC_BATTBRIGHTNESS, szWindowClass, MAX_LOADSTRING);

    //If it is already running, then focus on the window, and exit
    hWnd = FindWindow(szWindowClass, szTitle);	
    if (hWnd) 
    {
        // set focus to foremost child window
        // The "| 0x00000001" is used to bring any owned windows to the foreground and
        // activate them.
        SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
        return 0;
    } 

    if (!MyRegisterClass(hInstance, szWindowClass))
    {
    	return FALSE;
    }

    hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

    if (!hWnd)
    {
        return FALSE;
    }

  

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);


    return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;

    static SHACTIVATEINFO s_sai;
	
    switch (message) 
    {
        case WM_COMMAND:
            wmId    = LOWORD(wParam); 
            wmEvent = HIWORD(wParam); 
            // Parse the menu selections:
            switch (wmId)
            {
                case IDM_HELP_ABOUT:
                    DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, About);
                    break;
                case IDM_OK:
                    SendMessage (hWnd, WM_CLOSE, 0, 0);				
                    break;
                default:
                    return DefWindowProc(hWnd, message, wParam, lParam);
            }
            break;
        case WM_CREATE:
            SHMENUBARINFO mbi;

            memset(&mbi, 0, sizeof(SHMENUBARINFO));
            mbi.cbSize     = sizeof(SHMENUBARINFO);
            mbi.hwndParent = hWnd;
            mbi.nToolBarId = IDR_MENU;
            mbi.hInstRes   = g_hInst;

            if (!SHCreateMenuBar(&mbi)) 
            {
                g_hWndMenuBar = NULL;
            }
            else
            {
                g_hWndMenuBar = mbi.hwndMB;
            }

            // Initialize the shell activate info structure
            memset(&s_sai, 0, sizeof (s_sai));
            s_sai.cbSize = sizeof (s_sai);
			DialogBox(g_hInst, (LPCTSTR)IDD_DLG_MAIN, NULL, DlgMain);
            break;
        case WM_PAINT:
            hdc = BeginPaint(hWnd, &ps);
            
            // TODO: Add any drawing code here...
            
            EndPaint(hWnd, &ps);
            break;
        case WM_DESTROY:
            CommandBar_Destroy(g_hWndMenuBar);
            PostQuitMessage(0);
            break;

        case WM_ACTIVATE:
            // Notify shell of our activate message
            SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
            break;
        case WM_SETTINGCHANGE:
            SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
            break;

        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_INITDIALOG:
            {
                // Create a Done button and size it.  
                SHINITDLGINFO shidi;
                shidi.dwMask = SHIDIM_FLAGS;
                shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
                shidi.hDlg = hDlg;
                SHInitDialog(&shidi);
            }
            return (INT_PTR)TRUE;

        case WM_COMMAND:
            if (LOWORD(wParam) == IDOK)
            {
                EndDialog(hDlg, LOWORD(wParam));
                return TRUE;
            }
            break;

        case WM_CLOSE:
            EndDialog(hDlg, message);
            return TRUE;

#ifdef _DEVICE_RESOLUTION_AWARE
        case WM_SIZE:
            {
		DRA::RelayoutDialog(
			g_hInst, 
			hDlg, 
			DRA::GetDisplayMode() != DRA::Portrait ? MAKEINTRESOURCE(IDD_ABOUTBOX_WIDE) : MAKEINTRESOURCE(IDD_ABOUTBOX));
            }
            break;
#endif
    }
    return (INT_PTR)FALSE;
}




void ChangeBacklight()
{
	 HANDLE   g_evtSignal[2];
	 const TCHAR szevtBacklightChange[] = TEXT("BATT_BackLightChangeEvent");

	 g_evtSignal[0] = CreateEvent(NULL, FALSE, FALSE, szevtBacklightChange);
	 SetEvent(g_evtSignal[0]); 

}



////////////////////////////////////////////////////////
//	Called to retrieve the values corresponding to the
//  backlight stored in the registry. The necessary
//  registry values are described above
//
////////////////////////////////////////////////////////
HRESULT GetFromRegistry(HWND hDlg,DWORD eVal,DWORD *pdwValue,DWORD *pdwValueUnchecked)
{
	HKEY	hKey;
	DWORD	dwSize;
	DWORD	dwType;
	HRESULT	hRes;

	TCHAR	*szRegistryKey;
	TCHAR	*szRegValue1;


	switch (eVal)
	{
		case eBrightness:
			szRegistryKey	= REGKEY;
			szRegValue1		= BRIGHTNESS;
			break;

	    case ACBrightness:
			szRegistryKey	= REGKEY;
			szRegValue1		= ACBRIGHTNESS;
			break;

		default:
			return E_FAIL;
	}

	hRes = RegOpenKeyExW(HKEY_CURRENT_USER,szRegistryKey,0,KEY_ALL_ACCESS,&hKey);
	if (hRes != ERROR_SUCCESS)
		goto Done;
	

		dwSize = sizeof(DWORD);
		hRes = RegQueryValueExW(hKey,szRegValue1,0,&dwType,(LPBYTE)pdwValue,&dwSize);
		if (hRes != ERROR_SUCCESS)
			goto Done;

	
Done:
	RegCloseKey(hKey);
	return hRes;
}

// Message handler for Main box.
INT_PTR CALLBACK DlgMain(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

	   HWND	hwndSlider;
	   DWORD	dwValue;
	   	TCHAR szStatic[30];


	 switch (message)
    {
        case WM_INITDIALOG:
            {
                // Create a Done button and size it.  
                SHINITDLGINFO shidi;
                shidi.dwMask = SHIDIM_FLAGS;
                shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
                shidi.hDlg = hDlg;
                SHInitDialog(&shidi);

				GetFromRegistry(hDlg,eBrightness,&dwValue,NULL);            // get External Backlightness current slection

				hwndSlider = GetDlgItem(hDlg,IDC_BATT_SLIDER);
				SendMessage(hwndSlider,TBM_SETRANGE,TRUE,MAKELONG(1, 9));	// range
				SendMessage(hwndSlider,TBM_SETTICFREQ,1,0L);				// tick freq.
				SendMessage(hwndSlider,TBM_SETPAGESIZE,0L,1);				// page up/dn size
				SendMessage(hwndSlider,TBM_SETPOS,TRUE,dwValue/10);

				wsprintf(szStatic,_T("%d"),dwValue);
				SendMessage(GetDlgItem(hDlg,IDC_STATIC3),WM_SETTEXT,0,(LPARAM)szStatic);

			}
		 case WM_COMMAND:
            if (LOWORD(wParam) == IDOK)
            {	
				PostQuitMessage(0);
			}			
			break;
		case WM_HSCROLL:            // track bar message
			switch LOWORD(wParam) 
			{
				case TB_BOTTOM:
				case TB_THUMBPOSITION:
				case TB_LINEUP:
				case TB_LINEDOWN:
				case TB_PAGEUP:
				case TB_PAGEDOWN:
				case TB_TOP:
					hwndSlider = GetDlgItem(hDlg,IDC_BATT_SLIDER);
					if (hwndSlider == (HWND)lParam)
					{
						// The External Backlightness slider
						hwndSlider = GetDlgItem(hDlg,IDC_BATT_SLIDER);
						dwValue = SendMessage(hwndSlider,TBM_GETPOS,0,0);
						SetToRegistry(hDlg,eBrightness,dwValue*10);
						ChangeBacklight();
						wsprintf(szStatic,_T("%d"),dwValue*10);
						RETAILMSG(1,(TEXT("brightness slider is %d \r\n"),dwValue*10));
						SendMessage(GetDlgItem(hDlg,IDC_STATIC3),WM_SETTEXT,0,(LPARAM)szStatic);
					}
			}
			break;
			
	 }
	return (INT_PTR)FALSE;
}



////////////////////////////////////////////////////////
//	Called to save backlight related values to the
//  registry
//
////////////////////////////////////////////////////////
HRESULT SetToRegistry(HWND hDlg,DWORD eVal,DWORD dwValueChecked)
{
	HKEY	hKey;
	DWORD	dwDisp;
	HRESULT	hRes;

	TCHAR	*szRegistryKey;
	TCHAR	*szRegValue1;
	TCHAR	*szRegValue2;

	switch (eVal)
	{
		case eBrightness:
			szRegistryKey	= REGKEY;
			szRegValue1		= BRIGHTNESS;
			break;

		case ACBrightness:
			szRegistryKey	= REGKEY;
			szRegValue1		= ACBRIGHTNESS;
			break;

		default:
			return E_FAIL;
	}
	
	hRes = RegCreateKeyExW(HKEY_CURRENT_USER, szRegistryKey, 0, NULL, 0, KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
	if (hRes != ERROR_SUCCESS)
	{
		TCHAR szDebug[80];
		wsprintf(szDebug,L"RegCreateKeyExW failed with %d\n",hRes);
		OutputDebugString(szDebug);
		return hRes;
	}
	else
		OutputDebugString(L"RegCreateKeyExW succeeded\n");
	
	hRes = RegSetValueExW(hKey,szRegValue1,0,REG_DWORD,(LPBYTE)&dwValueChecked,sizeof(DWORD));


	RegCloseKey(hKey);                    
	
	return hRes;
}