// TakeSnapShotDlg.cpp : implementation file
//
//Modify date: 2008/01/10
//Purpose : Take Image and show image
//Process:
//		(1) call BCR_IOCTL_IMAGER_ENABLE DeviceIoControl
//		(1) Setting sBCR_GetImgCaptureDataIn.dwLeft = 300; (image left)
//		(2) Setting sBCR_GetImgCaptureDataIn.dwTop = 300; (image top)
//		(3) Setting sBCR_GetImgCaptureDataIn.dwRight = 300;(image right)
//		(4) Setting sBCR_GetImgCaptureDataIn.dwBottom = 300;(image bottom)
//		(5) Setting sBCR_GetImgCaptureDataIn.dwResolution = 1;
//		(6) Setting sBCR_GetImgCaptureDataIn.dwBitPerPiexl = 1; (1,4,8)
//		(7) Setting sBCR_GetImgCaptureDataIn.dwRotation = 0;
//		(8) Setting sBCR_GetImgCaptureDataIn.dwJPEGquality = 60;
//		(9) Setting sBCR_GetImgCaptureDataIn.dwSnapShot = 1;  ( 0 ,1 )
//		(10) Setting sBCR_GetImgCaptureDataIn.dwFileFormat = 1;	(1:JPEGFile, 3:BMPFile , 4:TIFFFile)
//		(11) Setting sBCR_TakeSnapshot.phWnd=phExtWnd;	(window handle)
//		(12) Setting sBCR_TakeSnapshot.pImgCapOp = &sBCR_GetImgCaptureDataIn;
//		(13) call BCR_IOCTL_TAKE_SNAPSHOT DeviceIoControl

#include "stdafx.h"
#include "TakeSnapShot.h"
#include "TakeSnapShotDlg.h"
#include "..\..\..\Inc\BCRService.h"
#include <winioctl.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CTakeSnapShotDlg dialog

HWND * phExtWnd;
HANDLE hFile;
HANDLE hKeyDown = NULL;
HANDLE hKeyUp = NULL;
static DWORD BCR_PRESS = BCR_TRIG_PRESS;
static DWORD BCR_RELEASE = BCR_TRIG_RELEASE;

#define MAX_LINE_SIZE	1280
#define MAX_IMG_HEIGHT	1024

int iregval = 0;
int iregval1 = 0;
int iregval2 = 0;
int iregval3 = 0;

HANDLE hTakeSnapshotEvent = NULL;
HANDLE hTakeSnapshotThread = NULL;

BOOL CTakeSnapShotDlg::InitTakeSnapshotThread(void)
{
	hTakeSnapshotEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	if(!hTakeSnapshotEvent) 
	{
		RETAILMSG(1, (TEXT("Create Snapshot Event Fail.\n")));
		return FALSE;
	}
	
	hTakeSnapshotThread = CreateThread((LPSECURITY_ATTRIBUTES)NULL, 0,(LPTHREAD_START_ROUTINE)TakeSnapshotThread, this, 0, NULL);
	if( hTakeSnapshotThread==NULL) 
	{
		RETAILMSG(1, (TEXT("Fail to create Take Snapshot Thread.\n")));
		return(FALSE);
	}
	return(TRUE);
}


void TakeSnapshotThread(CTakeSnapShotDlg *pCTakeSnapShotDlg)
{
	pCTakeSnapShotDlg->TakeSnapshotThread_Class();	
}

DWORD CTakeSnapShotDlg::TakeSnapshotThread_Class()
{	
	RETAILMSG(1,(TEXT(" TakeSnapshotThread \r\n")));
	while(1) 
	{
		DWORD dwWait;
		dwWait = WaitForSingleObject( hTakeSnapshotEvent, INFINITE);
        if (dwWait == WAIT_OBJECT_0) 
        {
		    RETAILMSG(1,(TEXT(" hTakeSnapshotEvent Event received !\r\n")));

			{
				// TODO: Take Snapshot
				TakeSnapshot(iregval, iregval1, iregval2, iregval3);
			}
		}
        else 
        {
		    RETAILMSG(1,(TEXT(" hTakeSnapshotEvent Error\r\n")));
            break;
        }
	}		
	return 0;
}

CTakeSnapShotDlg::CTakeSnapShotDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTakeSnapShotDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTakeSnapShotDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BPP_CBO, Bpp_combo);
	DDX_Control(pDX, IDC_TYPE_CBO, Type_combo);

}

BEGIN_MESSAGE_MAP(CTakeSnapShotDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_TAKESNAP_BTN, &CTakeSnapShotDlg::OnBnClickedTakesnapBtn)
	ON_MESSAGE( BCR_TAKE_PICTURE_INIT, OnPicInit )
	ON_MESSAGE( BCR_TAKE_PICTURE_PROCESS, OnPicProcess )
	ON_MESSAGE( BCR_TAKE_PICTURE_CANCELLING, OnPicCancel )
	ON_MESSAGE( BCR_TAKE_PICTURE_CANCELLED, OnPicCancelled)
	ON_MESSAGE( BCR_TAKE_PICTURE_DONE, OnPicDone )
	ON_MESSAGE( BCR_TAKE_PICTURE_BLOCK, OnPicBlock )
	ON_BN_CLICKED(IDC_CANCEL_BTN, &CTakeSnapShotDlg::OnBnClickedCancelBtn)
END_MESSAGE_MAP()


// implementation for BCR_TAKE_PICTURE_INIT handler
LRESULT CTakeSnapShotDlg::OnPicInit( WPARAM wParam, LPARAM lParam ) 
{
	SendDlgItemMessage(IDC_STATUS_LBL,WM_SETTEXT,0,(LPARAM)L"BCR_TAKE_PICTURE_INIT");
   // ... Handle message here
   return 0L;
}
// implementation for BCR_TAKE_PICTURE_PROCESS handler
LRESULT CTakeSnapShotDlg::OnPicProcess( WPARAM wParam, LPARAM lParam ) 
{
    // ... Handle message here
	SendDlgItemMessage(IDC_STATUS_LBL,WM_SETTEXT,0,(LPARAM)L"BCR_TAKE_PICTURE_PROCESS");
	RETAILMSG(1, (TEXT("[OnPicProcess] %d\n"),LOWORD(wParam)));	
	SendDlgItemMessage( IDC_PROGRESS, PBM_SETPOS, 0, 0);
	SendDlgItemMessage( IDC_PROGRESS, PBM_SETSTEP,(LPARAM)LOWORD(wParam), 0);
	SendDlgItemMessage( IDC_PROGRESS, PBM_STEPIT, 0, 0);	
	return 0L;
}
// implementation for BCR_TAKE_PICTURE_CANCELLING handler
LRESULT CTakeSnapShotDlg::OnPicCancel( WPARAM wParam, LPARAM lParam ) 
{
   // ... Handle message here
	SendDlgItemMessage(IDC_STATUS_LBL,WM_SETTEXT,0,(LPARAM)L"BCR_TAKE_PICTURE_CANCELLING");
   return 0L;
}
// implementation for BCR_TAKE_PICTURE_CANCELLED handler
LRESULT CTakeSnapShotDlg::OnPicCancelled( WPARAM wParam, LPARAM lParam ) 
{
   // ... Handle message here
	SendDlgItemMessage(IDC_STATUS_LBL,WM_SETTEXT,0,(LPARAM)L"BCR_TAKE_PICTURE_CANCELLED");
   return 0L;
}
// implementation for BCR_TAKE_PICTURE_DONE handler
LRESULT CTakeSnapShotDlg::OnPicDone( WPARAM wParam, LPARAM lParam ) 
{
   // ... Handle message here
	SendDlgItemMessage(IDC_STATUS_LBL,WM_SETTEXT,0,(LPARAM)L"BCR_TAKE_PICTURE_DONE");
   return 0L;
}

// implementation for BCR_TAKE_PICTURE_DONE handler
LRESULT CTakeSnapShotDlg::OnPicBlock( WPARAM wParam, LPARAM lParam ) 
{
   // ... Handle message here
	RETAILMSG(1,(TEXT("[OnPicBlock %d]\n"),LOWORD(wParam)));
	SendDlgItemMessage(IDC_PROGRESS, PBM_SETRANGE, 0, MAKELONG(0, LOWORD(wParam) ));
   return 0L;
}


// CTakeSnapShotDlg message handlers

BOOL CTakeSnapShotDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	SendDlgItemMessage(IDC_WIDTH_EDT,WM_SETTEXT,0,(LPARAM)L"200");
	SendDlgItemMessage(IDC_HEIGHT_EDT,WM_SETTEXT,0,(LPARAM)L"200");

	Bpp_combo.AddString(L"1 BPP"); //1 BPPAindex:0
	Bpp_combo.AddString(L"4 BPP"); //4 BPPAindex:1
	Bpp_combo.AddString(L"8 BPP"); //8 BPPAindex:2
	Bpp_combo.SetCurSel(0);

	Type_combo.AddString(L"JPEG"); //Jpeg formatAindex:0
	Type_combo.AddString(L"BMP");  //Bmp formatAindex:1
	Type_combo.AddString(L"TIFF"); //TIFF formatAindex:2
	Type_combo.SetCurSel(0);

	hFile = CreateFile( L"BCR0:",
                GENERIC_READ | GENERIC_WRITE,
                0,    // comm devices must be opened w/exclusive-access
                NULL, // no security attrs
                OPEN_EXISTING, // comm devices must use OPEN_EXISTING
                FILE_ATTRIBUTE_NORMAL,    // overlapped I/O 
                NULL  // hTemplate must be NULL for comm devices  
				);

    if ( hFile == INVALID_HANDLE_VALUE ) 
    {
		//RETAILMSG(1, (TEXT("Create BCR Err 1 \r\n")));
		AfxMessageBox ( _T("Creat BCR Service ERR!"));
    }

	//this event is used for KeyDown 
	hKeyDown = CreateEvent (NULL, TRUE, FALSE, L"Event_BCR_Trigger_KeyDown");
	HANDLE hKeyDown_Thread = CreateThread((LPSECURITY_ATTRIBUTES)NULL, 0,(LPTHREAD_START_ROUTINE)KeyDown, this, 0, NULL);
    if(hKeyDown_Thread==NULL)
          	RETAILMSG(1,(_T("Create ChangePhoneStatusOff thread failed. \n")));
    else
          	CloseHandle(hKeyDown_Thread);

	//this event is used for KeyUp 
	hKeyUp = CreateEvent (NULL, FALSE, FALSE, L"Event_BCR_Trigger_KeyUp");
	HANDLE hKeyUp_Thread = CreateThread((LPSECURITY_ATTRIBUTES)NULL, 0,(LPTHREAD_START_ROUTINE)KeyUp, this, 0, NULL);
    if(hKeyUp_Thread==NULL)
          	RETAILMSG(1,(_T("Create ChangePhoneStatusOff thread failed. \n")));
    else
          	CloseHandle(hKeyUp_Thread);

	InitTakeSnapshotThread();	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CTakeSnapShotDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	DRA::RelayoutDialog(
		AfxGetInstanceHandle(), 
		this->m_hWnd, 
		DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_TAKESNAPSHOT_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_TAKESNAPSHOT_DIALOG));
}
#endif
void KeyUp(CTakeSnapShotDlg *pCTakeSnapShotDlg)
{
	pCTakeSnapShotDlg->KeyUpClass();	
}
void CTakeSnapShotDlg::KeyUpClass()
{
	DWORD Result,Result1;
	while(TRUE)
	{
		if(WAIT_OBJECT_0 == WaitForSingleObject (hKeyUp, INFINITE))
		{	
			HANDLE hService = CreateFile(L"BCR0:",GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,0);			
			DeviceIoControl(hService, BCR_IOCTL_TRIGGER, &BCR_RELEASE, sizeof(DWORD), &Result, sizeof(DWORD), &Result1, NULL);																														
			CloseHandle(hService);

		}
	}
}
void KeyDown(CTakeSnapShotDlg *pCTakeSnapShotDlg)
{
	pCTakeSnapShotDlg->KeyDownClass();	
}
void CTakeSnapShotDlg::KeyDownClass()
{
	DWORD Result,Result1;
	while(TRUE)
	{
		if(WAIT_OBJECT_0 == WaitForSingleObject (hKeyDown, INFINITE))
		{							
			HANDLE hService = CreateFile(L"BCR0:",GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,0);			
			DeviceIoControl(hService, BCR_IOCTL_TRIGGER, &BCR_PRESS, sizeof(DWORD), &Result, sizeof(DWORD), &Result1, NULL);																														
			CloseHandle(hService);
			ResetEvent(hKeyDown);
		}
	}
}
void CTakeSnapShotDlg::OnBnClickedTakesnapBtn()
{
	// TODO: Add your control notification handler code here	

	TCHAR lpString[10];
	TCHAR lpString1[10];
	
	GetDlgItemText(IDC_WIDTH_EDT, lpString, 10);
	iregval = _wtoi(lpString);
	GetDlgItemText(IDC_HEIGHT_EDT, lpString1, 10);
	iregval1 = _wtoi(lpString1);
	switch(Bpp_combo.GetCurSel())
	{
		case 0: 			
				iregval2 = 1;
				break;
		case 1:
				iregval2 = 4;
				break;
		case 2:
				iregval2 = 8 ;
				break;
	}
	switch(Type_combo.GetCurSel())
	{
		case 0: 			
				iregval3 = 1;
				break;
		case 1:
				iregval3 = 3;
				break;
		case 2:
				iregval3 = 4 ;
				break;
	}	
	ImagerEnable();	
	SetEvent(hTakeSnapshotEvent);
	
}

void CTakeSnapShotDlg::ImagerEnable(void)
{
    DWORD dwResultBuf=0, dwResult=0;
    DeviceIoControl(hFile, BCR_IOCTL_IMAGER_ENABLE, NULL, 0, &dwResultBuf, sizeof(dwResultBuf), &dwResult, NULL);
    RETAILMSG(1, (TEXT("[BCR] Ena Status :  %x\n"), dwResultBuf));	
}

void CTakeSnapShotDlg::TakeSnapshot(int iW, int iH, int iBPP, int iType)
{
    DWORD dwResultBuf=0, dwResult=0;
	sBCR_TakeSnapshot ParamIn;
	sBCR_GetImgCaptureDataIn ImageCapOpIn;	
	HWND TstWnd;

	RETAILMSG(1, (TEXT("[BCR] W : %d, H : %d, BPP : %d , File : %d \n"),iW, iH, iBPP, iType));

	RETAILMSG(1, (TEXT("[BCR-] TakeSnapshot\n")));
    ImageCapOpIn.dwResolution = 1;
    ImageCapOpIn.dwBitPerPiexl = iBPP;
    ImageCapOpIn.dwRotation = 0;
    ImageCapOpIn.dwJPEGquality = 60;
    ImageCapOpIn.dwSnapShot = 1;  // 0 ,1 
    ImageCapOpIn.dwFileFormat = iType;	
	GetDlgItem(IDC_PIC_STATIC,&TstWnd);	
	phExtWnd = &TstWnd;	
    ParamIn.phWnd=phExtWnd;
	//ParamIn.phWnd=NULL;

	ParamIn.dwSize = sizeof(sBCR_TakeSnapshot);	
	ParamIn.hWnd_Progress = m_hWnd;		
	//ParamIn.hWnd_Progress = NULL;
	ParamIn.bProgressIndication = TRUE;
	ParamIn.dwLineCount = 20;	

    ParamIn.pImgCapOp = &ImageCapOpIn;
	if( iW > 1280 ||
		iH > 1024 ||
		(iBPP != 1	&&
		iBPP != 4	&&
		iBPP != 8)	||
		(iType != 1	&&
		iType != 3	&&
		iType != 4))
	{
		RETAILMSG(1, (TEXT("Wrong Parameter : W : 0-11290, H : 0-1024, BPP : 1:4:8, Type : 1:3:4 \n")));
		return;
	}
	ImageCapOpIn.dwLeft = (MAX_LINE_SIZE/2) - (iW/2);
	ImageCapOpIn.dwTop = (MAX_IMG_HEIGHT/2) - (iH/2);
	ImageCapOpIn.dwRight = (MAX_LINE_SIZE/2) + (iW/2);
	ImageCapOpIn.dwBottom = (MAX_IMG_HEIGHT/2) + (iH/2);

	DeviceIoControl(hFile, BCR_IOCTL_TAKE_SNAPSHOT, &ParamIn, sizeof(sBCR_TakeSnapshot), &dwResultBuf, sizeof(dwResultBuf), &dwResult, NULL);		
}

void CTakeSnapShotDlg::OnOK()
{
		CloseHandle( hFile );
		PostQuitMessage(0);
}
void CTakeSnapShotDlg::OnBnClickedCancelBtn()
{
	// TODO: Add your control notification handler code here
	DWORD Result=0, Result1=0;
    DeviceIoControl(hFile, BCR_IOCTL_STOP_IMGTFR, NULL, 0, &Result, sizeof(Result), &Result1, NULL);
    RETAILMSG(1, (TEXT("[BCR] BCR_IOCTL_STOP_IMGTFR State :  %x\n"), Result));	
}
