// ReadBarcode2File.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "ReadBarcode2File.h"
#include <windows.h>
#include <commctrl.h>
#include <winioctl.h>
#include "..\..\..\Inc\BCRService.h"
#define ServiceName L"BCR0:"
#define STR_FILENAME L"Note1.txt"
#define STR_MYDOC "\\My Documents"
#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE			g_hInst;			// current instance
HWND				g_hWndMenuBar;		// menu bar handle
sBCR_Status g_BCR_Status_AP;
HANDLE hReadGoodThread = NULL;
HANDLE		hGoodDecodeEVT = NULL;
HANDLE hService = INVALID_HANDLE_VALUE;
HWND hwBarcodeID_edt,hwNum_edt,hwFilename_edt;
TCHAR Event_Name[32];
// Forward declarations of functions included in this code module:
ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK DlgMain(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL InWideMode();
void ReadMoudleInfo();
DWORD WINAPI ThreadWaitGoodEvent( LPVOID lpParameter );
BOOL CreateBCRThread(HWND hDlg);
BOOL GetEventName(HWND hDlg);
void WriteToFile(HWND hDlg);

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	MSG msg;

	// Perform application initialization:
	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_READBARCODE2FILE));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_READBARCODE2FILE));
	wc.hCursor       = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;
    TCHAR szTitle[MAX_LOADSTRING];		// title bar text
    TCHAR szWindowClass[MAX_LOADSTRING];	// main window class name

    g_hInst = hInstance; // Store instance handle in our global variable

    // SHInitExtraControls should be called once during your application's initialization to initialize any
    // of the device specific controls such as CAPEDIT and SIPPREF.
    SHInitExtraControls();

    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
    LoadString(hInstance, IDC_READBARCODE2FILE, szWindowClass, MAX_LOADSTRING);

    //If it is already running, then focus on the window, and exit
    hWnd = FindWindow(szWindowClass, szTitle);	
    if (hWnd) 
    {
        // set focus to foremost child window
        // The "| 0x00000001" is used to bring any owned windows to the foreground and
        // activate them.
        SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
        return 0;
    } 

    if (!MyRegisterClass(hInstance, szWindowClass))
    {
    	return FALSE;
    }

    hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

    if (!hWnd)
    {
        return FALSE;
    }

  

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);


    return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;

    static SHACTIVATEINFO s_sai;
	
    switch (message) 
    {
        case WM_COMMAND:
            wmId    = LOWORD(wParam); 
            wmEvent = HIWORD(wParam); 
            // Parse the menu selections:
            switch (wmId)
            {
                
                case IDM_OK:
                    SendMessage (hWnd, WM_CLOSE, 0, 0);				
                    break;
                default:
                    return DefWindowProc(hWnd, message, wParam, lParam);
            }
            break;
        case WM_CREATE:
            SHMENUBARINFO mbi;

            memset(&mbi, 0, sizeof(SHMENUBARINFO));
            mbi.cbSize     = sizeof(SHMENUBARINFO);
            mbi.hwndParent = hWnd;
            mbi.nToolBarId = IDR_MENU;
            mbi.hInstRes   = g_hInst;

            if (!SHCreateMenuBar(&mbi)) 
            {
                g_hWndMenuBar = NULL;
            }
            else
            {
                g_hWndMenuBar = mbi.hwndMB;
            }

            // Initialize the shell activate info structure
            memset(&s_sai, 0, sizeof (s_sai));
            s_sai.cbSize = sizeof (s_sai);
			DialogBox(g_hInst, (LPCTSTR)IDD_DLG_MAIN, NULL, DlgMain);
            break;
        case WM_PAINT:
            hdc = BeginPaint(hWnd, &ps);
            
            // TODO: Add any drawing code here...
            
            EndPaint(hWnd, &ps);
            break;
        case WM_DESTROY:
            CommandBar_Destroy(g_hWndMenuBar);
            PostQuitMessage(0);
            break;

        case WM_ACTIVATE:
            // Notify shell of our activate message
            SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
            break;
        case WM_SETTINGCHANGE:
            SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
            break;

        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}



// Message handler for Main box.
INT_PTR CALLBACK DlgMain(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{


	HWND hwFilename_lbl,hwBarcodeID_lbl,hwNum_lbl;
	HWND hwNext_btn,hwExit_btn,hwVer_lbl;
	SHORT nState;
	DWORD Result =0,Result1 =0;
	static DWORD BCR_PRESS = BCR_TRIG_PRESS;
	static DWORD BCR_RELEASE = BCR_TRIG_RELEASE;

	hwFilename_lbl = GetDlgItem(hDlg,IDC_FILENAME_LBL ); 
	hwFilename_edt = GetDlgItem(hDlg,IDC_FILENAME_EDT ); 
	hwBarcodeID_lbl = GetDlgItem(hDlg,IDC_BARCODEID_LBL ); 
	hwBarcodeID_edt = GetDlgItem(hDlg,IDC_BARCODEID_EDT ); 
	hwNum_lbl = GetDlgItem(hDlg,IDC_NUM_LBL ); 
	hwNum_edt = GetDlgItem(hDlg,IDC_NUM_EDT ); 
	hwNext_btn = GetDlgItem(hDlg,IDC_NEXT_BTN ); 
	hwExit_btn = GetDlgItem(hDlg,IDC_EXIT_BTN ); 

	hwVer_lbl = GetDlgItem(hDlg,IDC_VER_LBL ); 

	 switch (message)
    {
        case WM_INITDIALOG:
            {
                // Create a Done button and size it.  
                SHINITDLGINFO shidi;
                shidi.dwMask = SHIDIM_FLAGS;
                shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
                shidi.hDlg = hDlg;
                SHInitDialog(&shidi);

				SendMessage(hwFilename_edt,WM_SETTEXT,0,(LPARAM)STR_FILENAME);		

				hService = CreateFile(ServiceName,GENERIC_READ | GENERIC_WRITE,	0,	NULL,	OPEN_EXISTING,	0,	0);			
				ReadMoudleInfo();

				ShowWindow(hwBarcodeID_edt,SW_HIDE);
				ShowWindow(hwNum_edt,SW_HIDE);

				switch(g_BCR_Status_AP.dwTriggerKey){
					case BCRSTATUS_TK_DEFAULT:
						{							
							if( ! RegisterHotKey(hDlg,OEM_VK_BCR_TRIGGER,MOD_KEYUP,OEM_VK_BCR_TRIGGER))
							::MessageBox( NULL, _T("ERROR registring Default key"), _T("ERROR"), MB_TOPMOST | MB_OK );
						}
						break;
					case BCRSTATUS_TK_OK:
						{							
							if( ! RegisterHotKey(hDlg,OEM_VK_BCR_TRIGGER,MOD_KEYUP,OEM_VK_BCR_TRIGGER))
							::MessageBox( NULL, _T("ERROR registring AP(OK) button"), _T("ERROR"), MB_TOPMOST | MB_OK );												
							
						}
						break;					
					case BCRSTATUS_TK_START:
						{							
							if( ! RegisterHotKey(hDlg,OEM_VK_BCR_TRIGGER,MOD_KEYUP,OEM_VK_BCR_TRIGGER))
							::MessageBox( NULL, _T("ERROR registring AP(OK) button"), _T("ERROR"), MB_TOPMOST | MB_OK );										
							
						}
						break;		
				}	

			}
		case WM_COMMAND:
			{
				if (LOWORD(wParam) == IDOK)
				{	
					PostQuitMessage(0);
				}	
				if (LOWORD(wParam) == IDC_EXIT_BTN)
				{	
					PostQuitMessage(0);
				}	
				if (LOWORD(wParam) == IDC_NEXT_BTN)
				{	

					ReadMoudleInfo();				
					ShowWindow(hwNum_edt,SW_HIDE);
					if(g_BCR_Status_AP.dwModuleEnable == BCRSTATUS_MOD_DISABLE){
						MessageBox( hDlg, _T("Please enable BCR Power"), _T("ERROR"), MB_TOPMOST | MB_OK |MB_ICONERROR );
						return FALSE;
					}
					if(g_BCR_Status_AP.dwKeyboardHook == BCRSTATUS_HOOK_ON){
						MessageBox( hDlg, _T("Please disable BCR keyboard hook"), _T("ERROR"), MB_TOPMOST | MB_OK |MB_ICONERROR );
						return FALSE;
					}
							
					if(g_BCR_Status_AP.dwKeyboardHook == BCRSTATUS_HOOK_OFF){	
						ShowWindow(hwBarcodeID_edt,SW_SHOW);						
						GetEventName(hDlg);							
						CreateBCRThread(hDlg);
						
						WriteToFile(hDlg);
						SendMessage(hwBarcodeID_edt,WM_SETTEXT,0,(LPARAM)L"");	
					}
		
				}	

			}
		case WM_HOTKEY:
			{								
					  switch (wParam)
						{
								case OEM_VK_BCR_TRIGGER:
									if( hService != INVALID_HANDLE_VALUE ){	
										 nState=GetAsyncKeyState(OEM_VK_BCR_TRIGGER);
										 if (HIBYTE(nState)){
											 DeviceIoControl(hService, BCR_IOCTL_TRIGGER, &BCR_PRESS, sizeof(DWORD), &Result, sizeof(DWORD), &Result1, NULL);																														
										 }
										 else{
											 DeviceIoControl(hService, BCR_IOCTL_TRIGGER, &BCR_RELEASE, sizeof(DWORD), &Result, sizeof(DWORD), &Result1, NULL);																														
										 }										
									}		
									break;								
					  }
			}
			break;
		case WM_SIZE:
			{
				  if (InWideMode() == TRUE){	
				  }
				  else{
					  SetWindowPos(hwFilename_lbl,NULL,30, 20, 55, 15, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);					  
					  SetWindowPos(hwFilename_edt,NULL,85, 20, 150, 25, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);					  
					  SetWindowPos(hwBarcodeID_lbl,NULL,10, 60, 75, 15, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);					  
					  SetWindowPos(hwBarcodeID_edt,NULL,85, 60, 150, 25, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);					  
					  SetWindowPos(hwNum_lbl,NULL,60, 100, 25, 15, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);					  
					  SetWindowPos(hwNum_edt,NULL,85, 100, 40, 25, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);					  					  
					  SetWindowPos(hwNext_btn,NULL,30, 150, 180, 30, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);					  
					  SetWindowPos(hwExit_btn,NULL,30, 200, 180, 30, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);					  
					  SetWindowPos(hwVer_lbl,NULL,185, 245, 80, 30, SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER);					  					  
				  }
			}
	 }
	 return (INT_PTR)FALSE;
}

void WriteToFile(HWND hDlg)
{	
	TCHAR strBarcodeID[100];
	TCHAR strNum[5];
	TCHAR strFilePath[100];
	int BufLen = 0;
	char szBarcodeID[100];
	char szPath[100];
	char szfilepath[100];
	char szNum[5];

	memset(strBarcodeID,0,sizeof(strBarcodeID));
	memset(strNum,0,sizeof(strNum));
	memset(szBarcodeID,0,sizeof(szBarcodeID));
	memset(szNum,0,sizeof(szNum));

	SendMessage(hwBarcodeID_edt,WM_GETTEXT,MAX_PATH, (LPARAM)strBarcodeID);
	SendMessage(hwNum_edt,WM_GETTEXT,MAX_PATH, (LPARAM)strNum);	
	SendMessage(hwFilename_edt,WM_GETTEXT,MAX_PATH, (LPARAM)strFilePath);	
	
	//RETAILMSG(1,(TEXT("[%s]\n"),strBarcodeID));
	//RETAILMSG(1,(TEXT("[%s]\n"),strNum));

	if(wcscmp(strBarcodeID,L"")==0)
		return;

	if(wcscmp(strNum,L"")==0){
		wcscpy(strNum,L"0");
	}

	wcstombs(szBarcodeID,strBarcodeID,sizeof(strBarcodeID));
	wcstombs(szNum,strNum,sizeof(strNum));
	wcstombs(szPath,strFilePath,sizeof(strFilePath));	
    sprintf(szfilepath,"%s\\%s",STR_MYDOC,szPath);


	FILE *stream;
	if ((stream = fopen (szfilepath, "a+t")) !=  NULL)
	{	
		fprintf (stream, "----------------------------------------\n");
		fprintf (stream, "Barcode Data = %s\n", szBarcodeID);	  
		fprintf (stream, "No = %s\n", szNum);	  
		fprintf (stream, "----------------------------------------\n");
	    fclose (stream);
	}
	else
	    printf ("Problem occurs when opening the initBCR.bcr \n");


}

BOOL InWideMode()
{
    int height = GetSystemMetrics(SM_CYSCREEN);
	return (height < 320) ? TRUE : FALSE;

}

void ReadMoudleInfo()
{	
 	if( hService != INVALID_HANDLE_VALUE ){		
	    DeviceIoControl(hService, BCR_IOCTL_GET_STATUS, NULL, 0, &g_BCR_Status_AP, sizeof(g_BCR_Status_AP), NULL, NULL);
	}
	else{
		MessageBox(NULL,L"BCR_IOCTL_GET_STATUS Command fail",L"ERROR",MB_OK);	
	}
}

BOOL GetEventName(HWND hDlg)
{

	DWORD Result1;	
	if( hService != INVALID_HANDLE_VALUE ){	
		if (DeviceIoControl(hService, BCR_IOCTL_GET_EVENTNAME, NULL, 0, Event_Name, sizeof(Event_Name)/sizeof(Event_Name[0]), &Result1, NULL)){	
			int idx;			
			for(idx=0; idx<13; idx++){
				RETAILMSG(1,(TEXT("%c"), (char)(Event_Name[idx])));
			}
			hGoodDecodeEVT = CreateEvent( NULL, TRUE, FALSE, Event_Name );
			if(hGoodDecodeEVT ==NULL){				
				MessageBox(hDlg,L"Create event fail",L"Error",MB_OK);				
				return FALSE;
			}			
		}
		else{
			MessageBox(hDlg,L"GET_EVENT_NAME Command fail",L"ERROR",MB_OK);				
		}
	}	
	return TRUE;
}


BOOL CreateBCRThread(HWND hDlg)
{
	DWORD dwThreadId;
	
	if( hGoodDecodeEVT != NULL )
	{

			hReadGoodThread = CreateThread( NULL, 
							  0,
							  &ThreadWaitGoodEvent,
							  NULL, //reinterpret_cast< void* >( &g_sSerial ),
							  0,
							  &dwThreadId);	
	}
	else
	{
		RETAILMSG(1,(TEXT("No Any Event need to Wait!\r\n")));
		return FALSE;
	}
	return TRUE;
}




DWORD WINAPI ThreadWaitGoodEvent( LPVOID lpParameter )
{
	DWORD dwResult;
	char lpBuffer[4096];
	TCHAR buffer[4096];		
	TCHAR buffer1[4096]  = L"";		
	TCHAR buffer2[4096];	
	char * tpBuf = lpBuffer;
	memset(lpBuffer, 0x0, 4096);
	while(1)
	{
	dwResult = WaitForSingleObject( hGoodDecodeEVT, INFINITE );
		
		if( dwResult == WAIT_OBJECT_0 ){		
			if( hService != INVALID_HANDLE_VALUE ){
				BOOL stat;
				DWORD ByteofRead = 0;
				DWORD SUM_ByteofRead = 0;
				ResetEvent( hGoodDecodeEVT );
				while(1)
				{
					Sleep(200);
					stat = ReadFile( hService, 
								 tpBuf, 
								 100, 
								 &ByteofRead, 
								 NULL
								);
					if( ByteofRead == 0 )
					{
						break;
					}
					else
					{
						tpBuf +=ByteofRead;
						SUM_ByteofRead += ByteofRead;
					}
					Sleep(10);

				}
				{
					DWORD idx;
					int index = 0;
					RETAILMSG(1,(TEXT("[Wind]Receive Data : \r\n")));
					for(idx=0; idx<SUM_ByteofRead; idx++)
					{
						RETAILMSG(1,(TEXT("%c"), (char)(lpBuffer[idx])));
					}
					RETAILMSG(1,(TEXT("\r\n")));
					memset(buffer, 0x0, 4096);
					memset(buffer2, 0x0, 4096);
					mbstowcs( buffer, lpBuffer ,sizeof(lpBuffer));													
					for(idx=0; idx<SUM_ByteofRead; idx++)
					{				
						buffer2[index++] = buffer[idx];
						if(buffer[idx] == 0x0D){																										
							wsprintf(buffer2,L"%s\n",buffer2);																								
							SendMessage(hwBarcodeID_edt,WM_SETTEXT,0,(LPARAM)buffer2);
							ShowWindow(hwNum_edt,SW_SHOW);
							ZeroMemory(buffer2,sizeof(buffer2));									
							index = 0;
						}																
					}										
					tpBuf = lpBuffer;
					SUM_ByteofRead = 0;
				}
			}		
		}
		else{
			MessageBox(NULL,L"ThreadWaitGoodEvent With Error",L"Error",MB_OK);					
			break;
		}
	}	
	return 0;
}



