REM Modify date: 2008/01/10
REM Purpose : Change the BCR module in "single read" or "multiple read"mode
REM Method:
REM     (1) BCRCom.BCR_UPDATE_SETTING(ref uint ResultOut) 
REM     Configure BCR Service and BCR Module by setting 
REM           (1.1)"BCRCom.dwMask_Status" to be
REM                   MASK_READ_MODE= &H10
REM           (1.2)"BCRCom.dwReadMode" to be
REM                   BCRSTATUS_RD_MODE_SINGLE = 1
REM                   BCRSTATUS_RD_MODE_MULTIPLE = 2
REM           (1.3)ResultOut is return value.    
Public Class Form1

    Dim MASK_READ_MODE As UInteger = &H10
    Dim BCRSTATUS_RD_MODE_MULTIPLE As UInteger = 2
    Dim BCRSTATUS_RD_MODE_SINGLE As UInteger = 1
    Dim Result As UInteger = 0
    Dim BCR_SUCCESS As UInteger = 1
    Dim BCRCom As BCRServiceCOMLib.BCR

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        BCRCom = New BCRServiceCOMLib.BCR
        BCRCom.dwMask_Status = MASK_READ_MODE
        BCRCom.dwReadMode = BCRSTATUS_RD_MODE_SINGLE
        BCRCom.BCR_UPDATE_SETTING(Result)
        If Result <> BCR_SUCCESS Then
            MessageBox.Show("Change Single Mode fail!")
        Else
            Button1.Enabled = False
            Button3.Enabled = True
            MessageBox.Show("Change Single Mode Success!")
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Application.Exit()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        BCRCom = New BCRServiceCOMLib.BCR
        BCRCom.dwMask_Status = MASK_READ_MODE
        BCRCom.dwReadMode = BCRSTATUS_RD_MODE_MULTIPLE
        BCRCom.BCR_UPDATE_SETTING(Result)
        If Result <> BCR_SUCCESS Then
            MessageBox.Show("Change Multiple Mode fail!")
        Else
            Button1.Enabled = True
            Button3.Enabled = False
            MessageBox.Show("Change Multiple Mode Success!")
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        BCRCom = New BCRServiceCOMLib.BCR
        If (BCRCom.dwReadMode = BCRSTATUS_RD_MODE_MULTIPLE) Then
            Button1.Enabled = True
            Button3.Enabled = False
        End If
        If (BCRCom.dwReadMode = BCRSTATUS_RD_MODE_SINGLE) Then
            Button1.Enabled = False
            Button3.Enabled = True
        End If
    End Sub
End Class
