REM Modify date: 2008/01/28
REM Purpose : Take Image and show image
REM Method:
REM           (1) Call BCRCom.BCR_IMAGER_ENABLE(Result) to enable image capture
REM               return error code "Result"
REM 
REM           (2) Call BCRCom.TakeSnapshot(Result) to take snapshot image capture, by setting
REM                 Set "BCRCom.dwImgBottom" for image bottom  
REM                 Set "BCRCom.dwImgTop" for image top
REM                 Set "BCRCom.dwImgLeft" for image left
REM                 Set "BCRCom.dwImgRight" for image right
REM                 Set "BCRCom.hShapWnd" to pass a image component handle to module 
REM                 Set "BCRCom.dwImgFileFormat" as
REM                 JPEGFile = 1;
REM                 BMPFile = 3;
REM                 TIFFFile = 4;
REM                 Set "BCRCom.dwImgBitPerPiexl" as
REM                 BitPerPiexl_1 = 1;
REM                 BitPerPiexl_4 = 4;
REM                 BitPerPiexl_8 = 8;
REM               return error code "Result"
REM           (3) Call BCRCom.BCR_STOP_IMG(Result) to stop image transforming
REM               return error code "Result"
REM           (4) When taking image, you can query
REM               "BCRCom.GetImgState" to know the status, like
REM                   "take picture process." means that it's taking image
REM                   "take picture done." means that job is done
REM                   "take picture cancel." means that job is canceled     
REM               "BCRCom.dwImgTotalPercent" to know the total process percentage 
REM               "BCRCom.dwImgPercent" to know the percentage of taking image      
REM           (5) Call BCRCom.BCR_TRIGGER(Trigger) to send trigger to BCR module, in this case
REM               "BCR_TRIG_PRESS" = 2 send key down trigger
REM               "BCR_TRIG_RELEASE" = 1 send key up trigger 
Imports System.Windows.Forms
Imports System.Threading
Imports System.Runtime.InteropServices

Public Class Form1
    Dim BCRCom As BCRServiceCOMLib.BCR
    Dim BCR_TRIG_PRESS As Integer = 2
    Dim BCR_TRIG_RELEASE As Integer = 1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        BPP_CMBO.SelectedIndex = 0
        Type_CMBO.SelectedIndex = 0
        Me.KeyPreview = True
        Me.Focus()
        Dim newThread As Thread
        newThread = New Thread(AddressOf ThreadFunc)
        newThread.IsBackground = True
        newThread.Start()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        
        BCRCom = New BCRServiceCOMLib.BCR
        Dim Result As UInteger = 0
        BCRCom.BCR_IMAGER_ENABLE(Result)
        BCRCom.dwImageHeight = Heigh_Text.Text
        BCRCom.dwImageWide = Width_Text.Text    
        BCRCom.hShapWnd = PictureBox1.Handle()

        If Type_CMBO.SelectedIndex = 0 Then
            BCRCom.dwImgFileFormat = 1
        ElseIf Type_CMBO.SelectedIndex = 1 Then
            BCRCom.dwImgFileFormat = 3
        ElseIf Type_CMBO.SelectedIndex = 2 Then
            BCRCom.dwImgFileFormat = 4
        End If

        If BPP_CMBO.SelectedIndex = 0 Then
            BCRCom.dwImgBitPerPiexl = 1
        ElseIf BPP_CMBO.SelectedIndex = 1 Then
            BCRCom.dwImgBitPerPiexl = 4
        ElseIf BPP_CMBO.SelectedIndex = 2 Then
            BCRCom.dwImgBitPerPiexl = 8
        End If
        Button1.Enabled = False
        BCRCom.TakeSnapshot(Result)
        
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim Result As UInteger = 0
        BCRCom.BCR_STOP_IMG(Result)
    End Sub
    Public Sub StatusUpdate(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Me.ImgStatus.Text = BCRCom.GetImgState
        Me.ImgStatus.Invalidate()
    End Sub
    Public Sub BarMax(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Me.ProgressBar1.Maximum = Convert.ToInt32(BCRCom.dwImgTotalPercent)       
        Me.ProgressBar1.Invalidate()
    End Sub
    Public Sub BarUpdate(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Me.ProgressBar1.Value = Convert.ToInt32(BCRCom.dwImgPercent)
        Me.ProgressBar1.Invalidate()        
    End Sub
    Private Sub ThreadFunc()        
        Dim hExit As New EventWaitHandle(False, EventResetMode.AutoReset, "Exit")
        REM Set up the named events.
        Dim hKeyDown As New EventWaitHandle(False, EventResetMode.AutoReset, "Event_BCR_Trigger_KeyDown")
        Dim hKeyUp As New EventWaitHandle(False, EventResetMode.AutoReset, "Event_BCR_Trigger_KeyUp")
        Dim hImgMsg As New EventWaitHandle(False, EventResetMode.AutoReset, "TAKE_IMAGE_MSG")
        Dim hImgPercent As New EventWaitHandle(False, EventResetMode.AutoReset, "TAKE_IMAGE_MSG_PERCENT")
        Dim hImgTatal As New EventWaitHandle(False, EventResetMode.AutoReset, "TAKE_IMAGE_MSG_TOTAL_BLOCK")

        While (True)
            Select Case EventWaitHandle.WaitAny(New WaitHandle() {hExit, hKeyDown, hKeyUp, hImgMsg, hImgPercent, hImgTatal})
                Case 0
                    Return
                Case 1
                    BCRCom.BCR_TRIGGER(BCR_TRIG_PRESS)
                Case 2
                    BCRCom.BCR_TRIGGER(BCR_TRIG_RELEASE)
                Case 3
                    ImgStatus.Invoke(New EventHandler(AddressOf StatusUpdate))
                Case 4
                    ProgressBar1.Invoke(New EventHandler(AddressOf BarUpdate))
                Case 5
                    ProgressBar1.Invoke(New EventHandler(AddressOf BarMax))
            End Select
        End While
    End Sub
    Private Sub Exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim hExit As New EventWaitHandle(False, EventResetMode.AutoReset, "Exit")
        hExit.Set()
        Me.Close()
        Application.Exit()
    End Sub
End Class
Public Enum EventResetMode
    AutoReset = 0
    ManualReset = 1
End Enum

Public Class EventWaitHandle
    Inherits WaitHandle

    Public Sub New(ByVal initialState As Boolean, ByVal mode As EventResetMode, ByVal name As String)
        Me.Handle = NativeMethods.CreateEvent(IntPtr.Zero, (mode = EventResetMode.ManualReset), initialState, name)
    End Sub

    Public Overrides Sub Close()
        If (Me.Handle <> WaitHandle.InvalidHandle) Then
            NativeMethods.CloseHandle(Me.Handle)
            Me.Handle = WaitHandle.InvalidHandle
        End If
    End Sub

    Public Function Reset() As Boolean
        Return NativeMethods.EventModify(Me.Handle, NativeMethods.EVENT.RESET)
    End Function

    Public Function [Set]() As Boolean
        Return NativeMethods.EventModify(Me.Handle, NativeMethods.EVENT.SET)
    End Function

    Public Shared Function WaitAny(ByVal waitHandles As WaitHandle()) As Integer
        Return EventWaitHandle.WaitAny(waitHandles, -1, False)
    End Function

    Public Shared Function WaitAny(ByVal waitHandles As WaitHandle(), ByVal millisecondsTimeout As Integer, ByVal exitContext As Boolean) As Integer
        Dim [handles] As IntPtr() = New IntPtr(waitHandles.Length - 1) {}
        Dim i As Integer = 0
        Do While (i < [handles].Length)
            [handles](i) = waitHandles(i).Handle
            i += 1
        Loop
        Return NativeMethods.WaitForMultipleObjects([handles].Length, [handles], False, millisecondsTimeout)
    End Function

    Public Overrides Function WaitOne() As Boolean
        Return Me.WaitOne(-1, False)
    End Function

    Public Overrides Function WaitOne(ByVal millisecondsTimeout As Integer, ByVal exitContext As Boolean) As Boolean
        Return (NativeMethods.WaitForSingleObject(Me.Handle, millisecondsTimeout) = 0)
    End Function

    Public Const WaitTimeout As Integer = &H102


    Friend Class NativeMethods

        <DllImport("coredll", SetLastError:=True)> _
        Friend Shared Function CloseHandle(ByVal hObject As IntPtr) As Boolean
        End Function

        <DllImport("coredll", SetLastError:=True)> _
        Friend Shared Function CreateEvent(ByVal lpEventAttributes As IntPtr, ByVal bManualReset As Boolean, ByVal bInitialState As Boolean, ByVal lpName As String) As IntPtr
        End Function

        <DllImport("coredll.dll", SetLastError:=True)> _
        Friend Shared Function EventModify(ByVal hEvent As IntPtr, ByVal ef As [EVENT]) As Boolean
        End Function

        <DllImport("coredll", SetLastError:=True)> _
        Friend Shared Function WaitForMultipleObjects(ByVal nCount As Integer, ByVal lpHandles As IntPtr(), ByVal fWaitAll As Boolean, ByVal dwMilliseconds As Integer) As Integer
        End Function

        <DllImport("coredll", SetLastError:=True)> _
        Friend Shared Function WaitForSingleObject(ByVal hHandle As IntPtr, ByVal dwMilliseconds As Integer) As Integer
        End Function

        Friend Enum [EVENT]
            PULSE = 1
            Reset = 2
            [Set] = 3
        End Enum

    End Class

End Class
