﻿Imports System
Imports System.Threading
Imports System.Runtime.InteropServices

Public Class Form2
    Dim BCRCom As BCRServiceCOMLib.BCR
    Dim LineCounter As Integer = 10
    Dim iLineCounter As Integer = 0
    Dim newThread As Thread

    
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        BCRCom = New BCRServiceCOMLib.BCR
        newThread = New Thread(AddressOf ThreadFunc)
        newThread.IsBackground = True
        newThread.Start()

    End Sub
    Public Sub BarUpdate(ByVal sender As System.Object, ByVal e As System.EventArgs)
        MessageBox.Show("Test")

        Me.ProgressBar1.Value = Me.ProgressBar1.Value + Convert.ToInt32(Me.ProgressBar1.Maximum / LineCounter)
        Me.ProgressBar1.Invalidate()
    End Sub
    Private Sub ThreadFunc()

        Dim hExit As New EventWaitHandle(False, EventResetMode.AutoReset, "Exit")
        Dim hConnected As New EventWaitHandle(False, EventResetMode.AutoReset, "TestData")

        While (True)

            Select Case EventWaitHandle.WaitAny(New WaitHandle() {hExit, hConnected})
                Case 0
                    Return
                Case 1
                    MessageBox.Show("Get event")
                    If (iLineCounter < LineCounter) Then
                        iLineCounter = iLineCounter + 1
                        ProgressBar1.Invoke(New EventHandler(AddressOf BarUpdate))
                    Else
                        Return
                    End If


            End Select
        End While

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.Close()
    End Sub
End Class

Public Enum EventResetMode
    AutoReset = 0
    ManualReset = 1
End Enum

Public Class EventWaitHandle
    Inherits WaitHandle

    Public Sub New(ByVal initialState As Boolean, ByVal mode As EventResetMode, ByVal name As String)
        Me.Handle = NativeMethods.CreateEvent(IntPtr.Zero, (mode = EventResetMode.ManualReset), initialState, name)
    End Sub

    Public Overrides Sub Close()
        If (Me.Handle <> WaitHandle.InvalidHandle) Then
            NativeMethods.CloseHandle(Me.Handle)
            Me.Handle = WaitHandle.InvalidHandle
        End If
    End Sub

    Public Function Reset() As Boolean
        Return NativeMethods.EventModify(Me.Handle, NativeMethods.EVENT.RESET)
    End Function

    Public Function [Set]() As Boolean
        Return NativeMethods.EventModify(Me.Handle, NativeMethods.EVENT.SET)
    End Function

    Public Shared Function WaitAny(ByVal waitHandles As WaitHandle()) As Integer
        Return EventWaitHandle.WaitAny(waitHandles, -1, False)
    End Function

    Public Shared Function WaitAny(ByVal waitHandles As WaitHandle(), ByVal millisecondsTimeout As Integer, ByVal exitContext As Boolean) As Integer
        Dim [handles] As IntPtr() = New IntPtr(waitHandles.Length - 1) {}
        Dim i As Integer = 0
        Do While (i < [handles].Length)
            [handles](i) = waitHandles(i).Handle
            i += 1
        Loop
        Return NativeMethods.WaitForMultipleObjects([handles].Length, [handles], False, millisecondsTimeout)
    End Function

    Public Overrides Function WaitOne() As Boolean
        Return Me.WaitOne(-1, False)
    End Function

    Public Overrides Function WaitOne(ByVal millisecondsTimeout As Integer, ByVal exitContext As Boolean) As Boolean
        Return (NativeMethods.WaitForSingleObject(Me.Handle, millisecondsTimeout) = 0)
    End Function

    Public Const WaitTimeout As Integer = &H102


    Friend Class NativeMethods

        <DllImport("coredll", SetLastError:=True)> _
        Friend Shared Function CloseHandle(ByVal hObject As IntPtr) As Boolean
        End Function

        <DllImport("coredll", SetLastError:=True)> _
        Friend Shared Function CreateEvent(ByVal lpEventAttributes As IntPtr, ByVal bManualReset As Boolean, ByVal bInitialState As Boolean, ByVal lpName As String) As IntPtr
        End Function

        <DllImport("coredll.dll", SetLastError:=True)> _
        Friend Shared Function EventModify(ByVal hEvent As IntPtr, ByVal ef As [EVENT]) As Boolean
        End Function

        <DllImport("coredll", SetLastError:=True)> _
        Friend Shared Function WaitForMultipleObjects(ByVal nCount As Integer, ByVal lpHandles As IntPtr(), ByVal fWaitAll As Boolean, ByVal dwMilliseconds As Integer) As Integer
        End Function

        <DllImport("coredll", SetLastError:=True)> _
        Friend Shared Function WaitForSingleObject(ByVal hHandle As IntPtr, ByVal dwMilliseconds As Integer) As Integer
        End Function

        Friend Enum [EVENT]
            PULSE = 1
            Reset = 2
            [Set] = 3
        End Enum

    End Class

End Class